﻿Imports iTextSharp.text

Public Class TableStyleTemplates
    Public Shared Function DefaultStyle() As TableStyle
        Return New TableStyle("Default")
    End Function

    Public Shared Function Gray_White() As TableStyle
        Dim temp As New TableStyle("Gray_White")
        temp.HeaderBorderWidths = New CellBorders(Of Single)(0.5, 0.5, 0, 0)

        temp.ContentBorderWidths = New CellBorders(Of Single)(0)
        temp.IteratingCellBackground.Add(New BaseColor(192, 192, 192))
        temp.IteratingCellBackground.Add(BaseColor.WHITE)

        temp.LastRowBorderWidths = New CellBorders(Of Single)(0, 0.5, 0, 0)

        Return temp
    End Function

    Public Shared Function Blue_White() As TableStyle
        Dim temp As New TableStyle("Blue_White")
        temp.HeaderBorderWidths = New CellBorders(Of Single)(0.5, 0.5, 0, 0)
        temp.HeaderBorderColors = New CellBorders(Of BaseColor)(New BaseColor(79, 129, 189))
        temp.FontHeader.SetColor(54, 95, 145)
        temp.FontTitle.SetColor(54, 95, 145)

        temp.ContentBorderWidths = New CellBorders(Of Single)(0)
        temp.FontContent.SetColor(54, 95, 145)
        temp.IteratingCellBackground.Add(New BaseColor(211, 223, 238))
        temp.IteratingCellBackground.Add(BaseColor.WHITE)

        temp.LastRowBorderColors = New CellBorders(Of BaseColor)(New BaseColor(79, 129, 189))
        temp.LastRowBorderWidths = New CellBorders(Of Single)(0, 0.5, 0, 0)

        Return temp
    End Function

    Public Shared Function LightGreen_White() As TableStyle
        Dim temp As New TableStyle("LightGreen-White")
        temp.HeaderBorderWidths = New CellBorders(Of Single)(0, 1, 0, 0)
        temp.HeaderBorderColors = New CellBorders(Of BaseColor)(New BaseColor(191, 227, 115))
        temp.FontHeader.SetColor(0, 0, 0)
        temp.FontTitle.SetColor(0, 0, 0)

        temp.ContentBorderWidths = New CellBorders(Of Single)(0.25, 0, 0.25, 0.25)
        temp.ContentBorderColors = New CellBorders(Of BaseColor)(New BaseColor(191, 227, 115))
        temp.FontContent.SetColor(0, 0, 0)
        temp.IteratingCellBackground.Add(New BaseColor(233, 246, 208))
        temp.IteratingCellBackground.Add(BaseColor.WHITE)

        temp.LastRowBorderColors = New CellBorders(Of BaseColor)(New BaseColor(191, 227, 115))
        temp.LastRowBorderWidths = New CellBorders(Of Single)(0.25)

        Return temp
    End Function
End Class
