﻿Imports iTextSharp.text
Imports iTextSharp.text.pdf
Imports System.IO
Imports System.Collections.ObjectModel
Imports System.Data
Imports FuncClasses

Partial Public Class CustomLayout
    Implements Biller.ICustomLayout

    'Private document As Document
    Public font_arial_15_bold, font_arial_9, font_arial_9_bold As Font
    Private writer As PdfWriter
    Public _auftrag As Order
    Private _path As String = ""
    Private xml As IDatabase

    Function TryParseInt(ByVal value As Object) As Decimal
        Try
            Return CDec(value)
        Catch ex As Exception
            Return (0)
        End Try
    End Function

    Function DecimalwithKomma(ByVal dec As Decimal) As String
        Return dec.ToString("0.00")
    End Function

    Private Function ArticleTableEnd(ByVal table As PdfPTable, auftrag As Order, ByVal zwischensumme As Money, steuersaetze As Collection(Of TaxClassMoneyModel), activecolumns As Integer,
                                     steuersaetzenl As Collection(Of TaxClassMoneyModel), listnebenleistung As Collection(Of OrderedArticle), document As Document) As Collection(Of IElement)
        Dim output As New Collection(Of IElement)
        Dim p1 As Phrase
        '### Nebenleistungen ###'
        Dim linkespalte As String = ""
        Dim rechtespalte As String = ""

        If auftrag.DokumentArt <> Dokumentart.Lieferschein Then
            Dim minuszeichen As String = If(CBool(GetSetting("Minus_abzgl")), "- ", "")
            If ((CBool(GetSetting("NoTaxes")) = False AndAlso CheckBox5.IsChecked) OrElse auftrag.Customer.IsCompany) Then
                '### Netto Rechnung ###'
                If String.IsNullOrEmpty(linkespalte) = False Then
                    linkespalte = ""
                    rechtespalte = ""
                End If

                Dim p2 As Phrase
                Dim cell2 As PdfPCell
                Dim bez As String = xml.TaxDescription
                Dim bezkurz As String = ""
                If bez = "mwst" Then : bez = "Mehrwertsteuer" : bezkurz = "MwSt." : ElseIf bez = "ust" Then : bez = "Umsatzsteuer" : bezkurz = "USt." : End If

                If Not CBool(GetSetting("AbroadInvoice")) Then
                    linkespalte += "Zwischensumme Netto"
                    rechtespalte += zwischensumme.ToString

                    For Each item In steuersaetze
                        linkespalte += vbCrLf + "Zzgl. " + item.TaxClass.TaxRate.ToString("0.00") + "% " + bezkurz + " auf " + item.Value.ToString
                        Dim value2 = ((item.Value * ((item.TaxClass.TaxRate / 100) + 1)) - item.Value)
                        rechtespalte += vbCrLf + value2.ToString
                        zwischensumme += value2
                    Next

                    p2 = New Phrase(linkespalte, font_arial_9)
                    cell2 = New PdfPCell(p2) : cell2.SetLeading(0, 1.2) : cell2.Colspan = activecolumns - 1 : cell2.PaddingBottom = 5.0F : table.AddCell(cell2)

                    p2 = New Phrase(rechtespalte, font_arial_9)
                    cell2 = New PdfPCell(p2) : cell2.HorizontalAlignment = Element.ALIGN_RIGHT : cell2.SetLeading(0, 1.2) : cell2.PaddingBottom = 5.0F : table.AddCell(cell2)
                End If


                If (auftrag.Reduction > 0 OrElse auftrag.Rebate > 0) Then
                    linkespalte = "Zwischensumme"
                    rechtespalte = zwischensumme.ToString
                    If auftrag.Reduction > 0 Then
                        linkespalte += vbCrLf + auftrag.ReductionText
                        rechtespalte += vbCrLf + minuszeichen + auftrag.Reduction.ToString
                    End If
                    If auftrag.Rebate > 0 Then
                        linkespalte += vbCrLf + "Abzgl. " + Math.Round(auftrag.Rebate * 100, 2).ToString + " % Gesamtrabatt"
                        rechtespalte += vbCrLf + minuszeichen + auftrag.RebateValue.ToString
                    End If

                    zwischensumme = zwischensumme - auftrag.Reduction - auftrag.RebateValue

                    p2 = New Phrase(linkespalte, font_arial_9)
                    cell2 = New PdfPCell(p2) : cell2.SetLeading(0, 1.2) : cell2.Colspan = activecolumns - 1 : cell2.PaddingBottom = 5.0F : table.AddCell(cell2)

                    p2 = New Phrase(rechtespalte, font_arial_9)
                    cell2 = New PdfPCell(p2) : cell2.HorizontalAlignment = Element.ALIGN_RIGHT : cell2.SetLeading(0, 1.2) : cell2.PaddingBottom = 5.0F : table.AddCell(cell2)
                End If

                If listnebenleistung.Count > 0 Then
                    linkespalte = "Zwischensumme"
                    rechtespalte = zwischensumme.ToString
                    For Each art In listnebenleistung
                        Dim temp As New TaxClassMoneyModel With {.TaxClass = art.TaxClass}
                        ' Erste Spalte '
                        linkespalte += vbCrLf + "Zzgl. " + art.ArticleDescription
                        ' Zweite Spalte '
                        rechtespalte += vbCrLf + art.NetOrderValue.ToString
                        steuersaetzenl(steuersaetzenl.IndexOf(temp)).Value += art.NetOrderValue.Amount
                        zwischensumme += art.NetOrderValue
                    Next

                    If Not CBool(GetSetting("AbroadInvoice")) Then
                        For Each item In steuersaetzenl
                            linkespalte += vbCrLf + "Zzgl. " + item.TaxClass.TaxRate.ToString("0.00") + "% " + bezkurz + " auf " + item.Value.ToString
                            rechtespalte += vbCrLf + ((item.Value * ((item.TaxClass.TaxRate / 100) + 1)) - item.Value).ToString
                        Next
                    End If

                    p2 = New Phrase(linkespalte, font_arial_9)
                    cell2 = New PdfPCell(p2) : cell2.SetLeading(0, 1.2) : cell2.Colspan = activecolumns - 1 : cell2.PaddingBottom = 5.0F : table.AddCell(cell2)

                    p2 = New Phrase(rechtespalte, font_arial_9)
                    cell2 = New PdfPCell(p2) : cell2.HorizontalAlignment = Element.ALIGN_RIGHT : cell2.SetLeading(0, 1.2) : cell2.PaddingBottom = 5.0F : table.AddCell(cell2)
                End If
            Else
                '### Brutto Rechnung ###'
                If (auftrag.Reduction > 0 OrElse auftrag.Rebate > 0) Then
                    linkespalte = "Zwischensumme"
                    rechtespalte = zwischensumme.ToString
                End If
                If auftrag.Reduction > 0 Then
                    linkespalte += vbCrLf + auftrag.ReductionText
                    rechtespalte += vbCrLf + minuszeichen + auftrag.Reduction.ToString
                End If
                If auftrag.Rebate > 0 Then
                    linkespalte += vbCrLf + "Abzgl. " + Math.Round(auftrag.Rebate * 100, 2).ToString + " % Gesamtrabatt"
                    rechtespalte += vbCrLf + minuszeichen + auftrag.RebateValue.ToString
                End If
                zwischensumme = zwischensumme - auftrag.Reduction - auftrag.RebateValue

                If Not String.IsNullOrEmpty(linkespalte) Then
                    Dim p2 As New Phrase(linkespalte, font_arial_9)
                    Dim cell2 As New PdfPCell(p2) : cell2.SetLeading(0, 1.2) : cell2.Colspan = activecolumns - 1 : cell2.PaddingBottom = 5.0F : table.AddCell(cell2)

                    p2 = New Phrase(rechtespalte, font_arial_9)
                    cell2 = New PdfPCell(p2) : cell2.HorizontalAlignment = Element.ALIGN_RIGHT : cell2.SetLeading(0, 1.2) : cell2.PaddingBottom = 5.0F : table.AddCell(cell2)
                End If

                If listnebenleistung.Count > 0 Then
                    linkespalte = "Zwischensumme"
                    rechtespalte = zwischensumme.ToString
                    For Each art In listnebenleistung
                        Dim temp As New TaxClassMoneyModel With {.TaxClass = art.TaxClass}
                        ' Erste Spalte '
                        linkespalte += vbCrLf + "Zzgl. " + art.ArticleDescription
                        ' Zweite Spalte '
                        rechtespalte += vbCrLf + art.GrossOrderValue.ToString
                        steuersaetzenl(steuersaetzenl.IndexOf(temp)).Value += art.GrossOrderValue.Amount
                        zwischensumme += art.GrossOrderValue.Amount
                    Next
                    Dim p2 As New Phrase(linkespalte, font_arial_9)
                    Dim cell2 As New PdfPCell(p2) : cell2.SetLeading(0, 1.2) : cell2.Colspan = activecolumns - 1 : cell2.PaddingBottom = 5.0F : table.AddCell(cell2)

                    p2 = New Phrase(rechtespalte, font_arial_9)
                    cell2 = New PdfPCell(p2) : cell2.HorizontalAlignment = Element.ALIGN_RIGHT : cell2.SetLeading(0, 1.2) : cell2.PaddingBottom = 5.0F : table.AddCell(cell2)
                End If
            End If
        End If

        '### Letzte Zeile der Tabelle ###'
        Select Case auftrag.DokumentArt
            Case Dokumentart.Rechnung
                p1 = New Phrase(" " + vbCrLf + "Gesamtbetrag", font_arial_9_bold)
            Case Dokumentart.Angebot
                p1 = New Phrase(" " + vbCrLf + "Gesamtbetrag", font_arial_9_bold)
            Case Dokumentart.Lieferschein
                p1 = New Phrase(" " + vbCrLf + "Gesamtgewicht", font_arial_9_bold)
            Case Dokumentart.Gutschrift
                p1 = New Phrase(" " + vbCrLf + "Gesamtbetrag", font_arial_9_bold)
        End Select

        Dim cell1 As New PdfPCell(CType(p1, Phrase))
        cell1.Colspan = activecolumns - 1
        cell1.PaddingBottom = 3.0F
        table.AddCell(cell1)

        If (CBool(GetSetting("NoTaxes")) = False AndAlso CheckBox5.IsChecked) AndAlso Not CBool(GetSetting("AbroadInvoice")) Then
            Select Case auftrag.DokumentArt
                Case Dokumentart.Rechnung
                    p1 = New Phrase(" " + vbCrLf + auftrag.TotalValueWithoutSkontoFromNet.ToString, font_arial_9_bold)
                Case Dokumentart.Angebot
                    p1 = New Phrase(" " + vbCrLf + auftrag.TotalValueWithoutSkontoFromNet.ToString, font_arial_9_bold)
                Case Dokumentart.Lieferschein
                    p1 = New Phrase(" " + vbCrLf + auftrag.TotalWeight + " " + Unit.GetByName("Kilogramm", xml).ShortName, font_arial_9_bold)
                Case Dokumentart.Gutschrift
                    p1 = New Phrase(" " + vbCrLf + auftrag.TotalValueWithoutSkontoFromNet.ToString, font_arial_9_bold)
            End Select
        ElseIf CBool(GetSetting("AbroadInvoice")) Then
            Select Case auftrag.DokumentArt
                Case Dokumentart.Rechnung
                    p1 = New Phrase(" " + vbCrLf + zwischensumme.ToString, font_arial_9_bold)
                Case Dokumentart.Angebot
                    p1 = New Phrase(" " + vbCrLf + zwischensumme.ToString, font_arial_9_bold)
                Case Dokumentart.Lieferschein
                    p1 = New Phrase(" " + vbCrLf + auftrag.TotalWeight + " " + Unit.GetByName("Kilogramm", xml).ShortName, font_arial_9_bold)
                Case Dokumentart.Gutschrift
                    p1 = New Phrase(" " + vbCrLf + zwischensumme.ToString, font_arial_9_bold)
            End Select
        Else
            Select Case auftrag.DokumentArt
                Case Dokumentart.Rechnung
                    p1 = New Phrase(" " + vbCrLf + auftrag.TotalValueWithoutSkonto.ToString, font_arial_9_bold)
                Case Dokumentart.Angebot
                    p1 = New Phrase(" " + vbCrLf + auftrag.TotalValueWithoutSkonto.ToString, font_arial_9_bold)
                Case Dokumentart.Lieferschein
                    p1 = New Phrase(" " + vbCrLf + auftrag.TotalWeight + " " + Unit.GetByName("Kilogramm", xml).ShortName, font_arial_9_bold)
                Case Dokumentart.Gutschrift
                    p1 = New Phrase(" " + vbCrLf + auftrag.TotalValueWithoutSkonto.ToString, font_arial_9_bold)
            End Select
        End If

        cell1 = New PdfPCell(CType(p1, Phrase))

        cell1.PaddingBottom = 3.0F
        cell1.HorizontalAlignment = Element.ALIGN_RIGHT
        table.AddCell(cell1)

        cell1 = New PdfPCell(New Phrase(New Chunk()))
        cell1.BorderWidthTop = 1.75F
        cell1.Border = Rectangle.TOP_BORDER
        cell1.Colspan = activecolumns
        table.AddCell(cell1)
        table.SpacingAfter = cm_to_px(0.5)
        Dim ph1 As New Paragraph()
        Select Case GetSetting("Table_position")
            Case "0"
                ph1.Alignment = Element.ALIGN_LEFT
                table.HorizontalAlignment = Element.ALIGN_LEFT
                ph1.IndentationLeft = cm_to_px(GetSetting("MarginSideTable")) - document.LeftMargin
            Case "1"
                ph1.Alignment = Element.ALIGN_CENTER
                table.HorizontalAlignment = Element.ALIGN_CENTER
            Case "2"
                ph1.Alignment = Element.ALIGN_RIGHT
                table.HorizontalAlignment = Element.ALIGN_RIGHT
                ph1.IndentationRight = cm_to_px(GetSetting("MarginSideTable")) - document.RightMargin
        End Select
        ph1.Add(table)

        output.Add(ph1)

        '### Sonstiger Text nach Tabelle ###'
        If (Not (auftrag.DokumentArt = Dokumentart.Angebot OrElse auftrag.DokumentArt = Dokumentart.Lieferschein)) AndAlso CBool(GetSetting("NoTaxes")) = False AndAlso CheckBox5.IsChecked = False AndAlso Not CBool(GetSetting("AbroadInvoice")) Then
            Dim bez As String = xml.TaxDescription
            Dim bezkurz As String = ""
            If bez = "mwst" Then : bez = "Mehrwertsteuer" : bezkurz = "MwSt." : ElseIf bez = "ust" Then : bez = "Umsatzsteuer" : bezkurz = "USt." : End If
            Dim para1 As New Paragraph(New Phrase("Die im Rechnungsbetrag enthaltene " + bez + " setzt sich wie folgt zusammen:", font_arial_9))
            para1.SpacingAfter = cm_to_px(0.2)
            output.Add(para1)
            Dim table2 As New PdfPTable({5.0F, 2.0F, 2.5F, 3.0F})
            table2.HorizontalAlignment = Element.ALIGN_LEFT
            If auftrag.DokumentArt = Dokumentart.Angebot OrElse auftrag.DokumentArt = Dokumentart.Rechnung OrElse auftrag.DokumentArt = Dokumentart.Gutschrift Then
                If (steuersaetze.Count + steuersaetzenl.Count) >= 1 Then
                    For Each item In steuersaetze
                        Dim c1 As New PdfPCell(New Phrase("Inkl. " + item.TaxClass.TaxRate.ToString("0.00") + "% " + bezkurz + " aus", font_arial_9))
                        c1.Border = Rectangle.NO_BORDER

                        '### Gesamtbetrag der jeweiligen Produkte in der Steuerklasse ###'
                        Dim c2 As PdfPCell
                        If CheckBox5.IsChecked Then
                            c2 = New PdfPCell(New Phrase("Netto " + (item.Value * (1 - auftrag.Rebate)).ToString, font_arial_9))
                        Else
                            c2 = New PdfPCell(New Phrase((item.Value * (1 - auftrag.Rebate)).ToString, font_arial_9))
                        End If

                        c2.HorizontalAlignment = Element.ALIGN_RIGHT
                        c2.Border = Rectangle.NO_BORDER

                        '### Steuerbetrag ###'
                        Dim c3 As New PdfPCell(New Phrase(DirectCast(((item.Value * (1 - auftrag.Rebate)) - (item.Value * (1 - auftrag.Rebate)) / ((item.TaxClass.TaxRate / 100) + 1)), Money).ToString, font_arial_9))
                        c3.HorizontalAlignment = Element.ALIGN_RIGHT
                        c3.Border = Rectangle.NO_BORDER

                        Dim c4 As New PdfPCell(New Phrase("", font_arial_9))
                        c4.HorizontalAlignment = Element.ALIGN_RIGHT
                        c4.Border = Rectangle.NO_BORDER

                        table2.AddCell(c1)
                        table2.AddCell(c2)
                        table2.AddCell(c3)
                        table2.AddCell(c4)
                    Next

                    For Each item In steuersaetzenl
                        Dim c1 As New PdfPCell(New Phrase("Inkl. " + item.TaxClass.TaxRate.ToString("0.00") + "% " + bezkurz + " aus", font_arial_9))
                        c1.Border = Rectangle.NO_BORDER

                        '### Gesamtbetrag der jeweiligen Produkte in der Steuerklasse ###'
                        Dim c2 As PdfPCell
                        If CheckBox5.IsChecked Then
                            c2 = New PdfPCell(New Phrase("Netto " + (item.Value * (1 - auftrag.Rebate)).ToString, font_arial_9))
                        Else
                            c2 = New PdfPCell(New Phrase((item.Value * (1 - auftrag.Rebate)).ToString, font_arial_9))
                        End If

                        c2.HorizontalAlignment = Element.ALIGN_RIGHT
                        c2.Border = Rectangle.NO_BORDER

                        '### Steuerbetrag ###'
                        Dim c3 As New PdfPCell(New Phrase(DirectCast(((item.Value * (1 - auftrag.Rebate)) - (item.Value * (1 - auftrag.Rebate)) / ((item.TaxClass.TaxRate / 100) + 1)), Money).ToString, font_arial_9))
                        c3.HorizontalAlignment = Element.ALIGN_RIGHT
                        c3.Border = Rectangle.NO_BORDER

                        Dim c4 As New PdfPCell(New Phrase("auf Nebenleistungen", font_arial_9))
                        c4.HorizontalAlignment = Element.ALIGN_RIGHT
                        c4.Border = Rectangle.NO_BORDER

                        table2.AddCell(c1)
                        table2.AddCell(c2)
                        table2.AddCell(c3)
                        table2.AddCell(c4)
                    Next
                ElseIf steuersaetze.Count = 1 Then
                    'Dim item As String = steuersaetze(0)
                    'ToDo: Wenn nur ein Steuersatz da ist, schönere Variante entwerfen
                End If
            End If
            output.Add(table2)
        End If
        Zahlungsart(auftrag, output)
        Auftragstext(auftrag, output)
        Return output
    End Function

    Private Function GetArticleTable(ByRef activecolumns As Integer, ByVal spacingbefore As Boolean, ByRef dt As DataTable, document As Document) As PdfPTable
        Dim collectionwidth As New Collection(Of Single)
        Select Case _auftrag.DokumentArt
            Case Dokumentart.Rechnung
                dt = tbl_rechnung
            Case Dokumentart.Lieferschein
                dt = tbl_lieferschein
            Case Dokumentart.Angebot
                dt = tbl_angebot
            Case Dokumentart.Gutschrift
                dt = tbl_gutschrift
        End Select
        For Each r As DataRow In dt.Rows
            If r("Active") = "True" Then
                If r("Name") = "Artikeltext" Then
                Else
                    activecolumns += 1
                    collectionwidth.Add(CSng(r("Breite")))
                End If
            End If
        Next
        Dim colswidth() As Single = collectionwidth.ToArray
        Dim table As New PdfPTable(colswidth)
        table.WidthPercentage = (cm_to_px(CDec(GetSetting("Table_width"))) / (cm_to_px(21) - Document.LeftMargin - Document.RightMargin)) * 100
        If spacingbefore Then
            table.SpacingBefore = 0 'cm_to_px(1)
            table.SpacingAfter = 0
        Else
            table.SpacingBefore = 0
            table.SpacingAfter = 0
        End If

        Return table
    End Function

    Private Sub Zahlungsart(ByRef auftrag As Order, ByRef list As Collection(Of IElement))
        '### Zahlungskonditionen ###'
        If auftrag.PaymentMethode IsNot Nothing AndAlso Not (auftrag.PaymentMethode.Name = "-1") Then
            Dim temp As String = auftrag.PaymentMethode.Text
            If CBool(GetSetting("NoTaxes")) = False AndAlso CheckBox5.IsChecked Then
                temp = temp.Replace("{0}", auftrag.SkontoValueFromNet.ToString)
                temp = temp.Replace("{1}", auftrag.TotalValueFromNet.ToString)
            Else
                temp = temp.Replace("{0}", auftrag.SkontoValue.ToString)
                temp = temp.Replace("{1}", auftrag.TotalValue.ToString)
            End If
            list.Add(New Phrase(vbCrLf + temp + vbCrLf + " ", font_arial_9))
        End If
    End Sub

    Private Sub Auftragstext(ByRef auftrag As Order, ByRef list As Collection(Of IElement))
        '### Zusätzlicher Auftragstext ###'
        If String.IsNullOrEmpty(auftrag.OrderText) = False Then
            list.Add(New Phrase(vbCrLf + auftrag.OrderText, font_arial_9))
        End If
    End Sub

    Private Sub OrderStartText(ByRef auftrag As Order, ByRef list As Collection(Of IElement))
        '### Zusätzlicher Auftragstext ###'
        If String.IsNullOrEmpty(auftrag.TextBefore) = False Then
            list.Add(New Phrase(vbCrLf + auftrag.TextBefore, font_arial_9))
        End If
    End Sub

    Public Sub Header(ByVal auftrag As Order, document As Document)
        document.Add(New Chunk)
        Dim p1 As Phrase
        '###Adresse(n)###'
        Dim b As Boolean = CBool(GetSetting("Print_sender"))
        If b Then
            'Absender
            Dim phrase1 As Chunk
            With xml.GetCompanySettings(xml.LastCompany)
                phrase1 = New Chunk(xml.LastCompany + ", " + .Street + " " + .No + ", " + .ZipCode + " " + .City)
            End With
            phrase1.Font = font_arial_9
            Dim ph1 As New Paragraph(phrase1)
            ph1.SpacingBefore = cm_to_px(TryParseInt(GetSetting("Margin_Sender_Top")))
            ph1.IndentationLeft = cm_to_px(TryParseInt(GetSetting("Margin_Sender_Left"))) - document.LeftMargin
            ph1.SpacingAfter = cm_to_px(TryParseInt(GetSetting("Margin_Sender_Bottom")))

            Dim p2 As New Paragraph(GetEmpfängerAdresse(auftrag.Customer, font_arial_9, auftrag))
            p2.SpacingBefore = cm_to_px(TryParseInt(GetSetting("Margin_Receiver_Top")))
            p2.SpacingAfter = cm_to_px(TryParseInt(GetSetting("Margin_Receiver_Bottom")))
            p2.IndentationLeft = cm_to_px(TryParseInt(GetSetting("Margin_receiver"))) - document.LeftMargin

            document.Add(ph1)
            document.Add(p2)
        Else
            'Keine Absenderzeile
            Dim ph1 As New Paragraph(GetEmpfängerAdresse(auftrag.Customer, font_arial_9, auftrag))
            ph1.SpacingBefore = cm_to_px(TryParseInt(GetSetting("Margin_Receiver_Top")))
            ph1.SpacingAfter = cm_to_px(TryParseInt(GetSetting("Margin_Receiver_Bottom")))
            ph1.IndentationLeft = cm_to_px(TryParseInt(GetSetting("Margin_receiver"))) - document.LeftMargin
            document.Add(ph1)
        End If

        '###Kundennummer, Datum###'
        If True Then
            Dim table As New PdfPTable(2)
            table.LockedWidth = True
            table.SetTotalWidth({cm_to_px(2.75), cm_to_px(2.25)})
            Dim cell1 As PdfPCell
            If Not String.IsNullOrEmpty(auftrag.Customer.CustomerID) Then
                p1 = New Phrase("Kundennummer:", font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                table.AddCell(cell1)
                p1 = New Phrase(auftrag.Customer.CustomerID, font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                cell1.HorizontalAlignment = Element.ALIGN_RIGHT
                table.AddCell(cell1)
            End If
            '### -- Date Start -- ####'
            p1 = New Phrase("Datum:", font_arial_9)
            cell1 = New PdfPCell(p1)
            cell1.Border = Rectangle.NO_BORDER
            table.AddCell(cell1)

            p1 = New Phrase(auftrag.Datum.ToString, font_arial_9)
            cell1 = New PdfPCell(p1)
            cell1.Border = Rectangle.NO_BORDER
            cell1.HorizontalAlignment = Element.ALIGN_RIGHT
            table.AddCell(cell1)
            '### -- Date End -- ####'

            '### -- UserName Start -- ####'
            If CBool(GetSetting("ShowUserName")) Then
                p1 = New Phrase("Bearbeiter:", font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                table.AddCell(cell1)

                p1 = New Phrase(auftrag.LastEditBy.UserName, font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                cell1.HorizontalAlignment = Element.ALIGN_RIGHT
                table.AddCell(cell1)
            End If
            '### -- UserName End -- ####'

            '### -- UserID Start -- ####'
            If CBool(GetSetting("ShowUserID")) Then
                p1 = New Phrase("Bearbeiternr.:", font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                table.AddCell(cell1)

                p1 = New Phrase(auftrag.LastEditBy.UserID, font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                cell1.HorizontalAlignment = Element.ALIGN_RIGHT
                table.AddCell(cell1)
            End If
            '### -- UserID End -- ####'

            '### -- PageCount -- ####'
            If GetSetting("ShowPageCount") Then
                p1 = New Phrase("Seite:", font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                table.AddCell(cell1)

                p1 = New Phrase(CurrentPageCount.ToString("0") + " von " + TotalPageCount.ToString("0"), font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                cell1.HorizontalAlignment = Element.ALIGN_RIGHT
                table.AddCell(cell1)
            End If

            Dim ph1 As New Paragraph()
            Select Case GetSetting("Alignment_Date")
                Case "Left"
                    table.HorizontalAlignment = Element.ALIGN_LEFT
                    ph1.IndentationLeft = cm_to_px(TryParseInt(GetSetting("Margin_Date_Side"))) - document.LeftMargin
                Case "Right"
                    table.HorizontalAlignment = Element.ALIGN_RIGHT
                    ph1.IndentationRight = cm_to_px(TryParseInt(GetSetting("Margin_Date_Side"))) - document.RightMargin
            End Select

            ph1.Add(table)
            If CurrentPageCount = 1 Then
                ph1.SpacingAfter = cm_to_px(TryParseInt(GetSetting("Margin_Date_Bottom")))
            Else
                ph1.SpacingAfter = 0
            End If

            ph1.SpacingBefore = cm_to_px(TryParseInt(GetSetting("Margin_Date_Top")))

            document.Add(ph1)
        End If
        '### Rechnungsnummer ###'
        If True Then
            Dim table = New PdfPTable(1)
            Dim cell = New PdfPCell(New Phrase(auftrag.DokumentArt.ToString + " Nr. " + auftrag.OrderID.ToString, font_arial_15_bold)) With {.Border = Rectangle.NO_BORDER}
            table.AddCell(cell)
            table.HorizontalAlignment = Element.ALIGN_LEFT
            Dim ph1 As New Paragraph()
            ph1.Alignment = Element.ALIGN_LEFT
            If CurrentPageCount = 1 Then
                ph1.SpacingAfter = cm_to_px(GetSetting("MarginBotDocumentNumber"))
            Else
                table.AddCell(New PdfPCell(New Phrase(" ")) With {.Border = Rectangle.NO_BORDER})
            End If
            ph1.Add(table)
            ph1.IndentationLeft = cm_to_px(GetSetting("MarginLeftDocumentNumber")) - document.LeftMargin
            ph1.SpacingBefore = cm_to_px(GetSetting("MarginTopDocumentNumber"))
            document.Add(ph1)
        End If

        '### Wasserzeichen ###'
        If Not String.IsNullOrEmpty(GetSetting("PDF_Briefpapier")) Then
            Try
                Dim mark As PdfReader = New PdfReader(GetSetting("PDF_Briefpapier"))
                Dim mark_page_size As Rectangle = mark.GetPageSize(1)

                Dim markpage As PdfImportedPage = writer.GetImportedPage(mark, 1)

                Dim contentByte As PdfContentByte = writer.DirectContentUnder

                contentByte.AddTemplate(markpage, 0, 0)
            Catch ex As Exception : End Try
        End If
    End Sub

    Public Sub SmallHeader(ByVal auftrag As Order, document As Document)
        ' document.Add(New Chunk(""))
        Dim p1 As Phrase
        '###Kundennummer, Datum###'
        If True Then
            Dim table As New PdfPTable(2)
            table.LockedWidth = True
            table.SetTotalWidth({cm_to_px(2.75), cm_to_px(2.25)})
            Dim cell1 As PdfPCell
            If Not String.IsNullOrEmpty(auftrag.Customer.CustomerID) Then
                p1 = New Phrase("Kundennummer:", font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                table.AddCell(cell1)
                p1 = New Phrase(auftrag.Customer.CustomerID, font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                cell1.HorizontalAlignment = Element.ALIGN_RIGHT
                table.AddCell(cell1)
            End If
            '### -- Date Start -- ####'
            p1 = New Phrase("Datum:", font_arial_9)
            cell1 = New PdfPCell(p1)
            cell1.Border = Rectangle.NO_BORDER
            table.AddCell(cell1)

            p1 = New Phrase(auftrag.Datum.ToString, font_arial_9)
            cell1 = New PdfPCell(p1)
            cell1.Border = Rectangle.NO_BORDER
            cell1.HorizontalAlignment = Element.ALIGN_RIGHT
            table.AddCell(cell1)
            '### -- Date End -- ####'

            '### -- UserName Start -- ####'
            If CBool(GetSetting("ShowUserName")) Then
                p1 = New Phrase("Bearbeiter:", font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                table.AddCell(cell1)

                p1 = New Phrase(auftrag.LastEditBy.UserName, font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                cell1.HorizontalAlignment = Element.ALIGN_RIGHT
                table.AddCell(cell1)
            End If
            '### -- UserName End -- ####'

            '### -- UserID Start -- ####'
            If CBool(GetSetting("ShowUserID")) Then
                p1 = New Phrase("Bearbeiternr.:", font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                table.AddCell(cell1)

                p1 = New Phrase(auftrag.LastEditBy.UserID, font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                cell1.HorizontalAlignment = Element.ALIGN_RIGHT
                table.AddCell(cell1)
            End If
            '### -- UserID End -- ####'

            '### -- PageCount -- ####'
            If GetSetting("ShowPageCount") Then
                p1 = New Phrase("Seite:", font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                table.AddCell(cell1)

                p1 = New Phrase(CurrentPageCount.ToString("0") + " von " + TotalPageCount.ToString("0"), font_arial_9)
                cell1 = New PdfPCell(p1)
                cell1.Border = Rectangle.NO_BORDER
                cell1.HorizontalAlignment = Element.ALIGN_RIGHT
                table.AddCell(cell1)
            End If

            Dim ph1 As New Paragraph()
            Select Case GetSetting("Alignment_Date")
                Case "Left"
                    ph1.Alignment = Element.ALIGN_LEFT
                    table.HorizontalAlignment = Element.ALIGN_LEFT
                    ph1.IndentationLeft = cm_to_px(TryParseInt(GetSetting("Margin_Date_Side"))) - document.LeftMargin
                Case "Right"
                    ph1.Alignment = Element.ALIGN_RIGHT
                    table.HorizontalAlignment = Element.ALIGN_RIGHT
                    ph1.IndentationRight = cm_to_px(TryParseInt(GetSetting("Margin_Date_Side"))) - document.RightMargin
            End Select

            ph1.Add(table)
            'ph1.SpacingAfter = cm_to_px(TryParseInt(GetSetting("Margin_Date_Bottom")))
            ph1.SpacingBefore = cm_to_px(TryParseInt(GetSetting("Margin_Date_Top")))

            document.Add(ph1)
        End If

        '### Rechnungsnummer ###'
        If True Then
            Dim table = New PdfPTable(1)
            Dim cell = New PdfPCell(New Phrase(auftrag.DokumentArt.ToString + " Nr. " + auftrag.OrderID.ToString, font_arial_15_bold)) With {.Border = Rectangle.NO_BORDER}
            table.AddCell(cell)
            table.HorizontalAlignment = Element.ALIGN_LEFT
            Dim ph1 As New Paragraph()
            ph1.Alignment = Element.ALIGN_LEFT
            If CurrentPageCount = 1 Then
                ph1.SpacingAfter = cm_to_px(GetSetting("MarginBotDocumentNumber"))
            Else
                table.AddCell(New PdfPCell(New Phrase(" ")) With {.Border = Rectangle.NO_BORDER})
            End If
            ph1.Add(table)
            ph1.IndentationLeft = cm_to_px(GetSetting("MarginLeftDocumentNumber")) - document.LeftMargin
            ph1.SpacingBefore = cm_to_px(GetSetting("MarginTopDocumentNumber"))
            document.Add(ph1)
        End If

        '### Wasserzeichen ###'
        If Not String.IsNullOrEmpty(GetSetting("PDF_Briefpapier")) Then
            Try
                Dim mark As PdfReader = New PdfReader(GetSetting("PDF_Briefpapier"))
                Dim mark_page_size As Rectangle = mark.GetPageSize(1)

                Dim markpage As PdfImportedPage = writer.GetImportedPage(mark, 1)

                Dim contentByte As PdfContentByte = writer.DirectContentUnder

                contentByte.AddTemplate(markpage, 0, 0)
            Catch ex As Exception : End Try
        End If
    End Sub

    Public Function GetEmpfängerAdresse(ByVal kunde As Customer, ByVal font As Font, order As Order) As Phrase
        Dim phrase1 As Chunk = New Chunk("")
        If CheckBox4.IsChecked AndAlso order.DeliveryAddress IsNot Nothing AndAlso order.DokumentArt = Dokumentart.Lieferschein Then
            phrase1 = New Chunk(order.DeliveryAddress.ToStringWithNewLine(CheckBox2.IsChecked, GetSetting("ShowContactPerson")))
        Else
            phrase1 = New Chunk(order.Customer.Address.ToStringWithNewLine(CheckBox2.IsChecked, GetSetting("ShowContactPerson")))
        End If

        phrase1.Font = font
        Dim p1 As New Phrase(phrase1)
        p1.Leading = p1.Leading / 1.4
        Return p1
    End Function

    Public Function cm_to_px(ByVal cm As Decimal) As Integer
        Return (cm / 2.54) * 72
    End Function

    Public ReadOnly Property Author As String Implements Biller.ICustomLayout.Author
        Get
            Return "Igor Lückel"
        End Get
    End Property

    Public Property MainWindow As Biller.Window1 Implements Biller.ICustomLayout.MainWindow
        Get
            Return _parentform
        End Get
        Set(value As Biller.Window1)
            _parentform = value
        End Set
    End Property

    Public ReadOnly Property Name As String Implements Biller.ICustomLayout.Name
        Get
            Return "Standardlayout"
        End Get
    End Property

    Public Sub Print(auftrag As Order) Implements Biller.ICustomLayout.Print
        Dim prevstate As Boolean = CheckBox5.IsChecked
        If auftrag.Customer.IsCompany Then
            CheckBox5.IsChecked = True
        End If

        Dim reader As New PdfReader(DirectCast(CreatePDF(auftrag, New MemoryStream()), MemoryStream).ToArray)
        TotalPageCount = reader.NumberOfPages
        CurrentPageCount = 1
        _path = System.AppDomain.CurrentDomain.BaseDirectory() + "\temp.pdf"
        CreatePDF(auftrag, New FileStream(_path, FileMode.Create))
        Process.Start(_path)

        CheckBox5.IsChecked = prevstate
    End Sub

    Public Sub Save(auftrag As Order, PathToSave As String) Implements Biller.ICustomLayout.Save
        Dim prevstate As Boolean = CheckBox5.IsChecked
        If auftrag.Customer.IsCompany Then
            CheckBox5.IsChecked = True
        End If
        Dim reader As New PdfReader(DirectCast(CreatePDF(auftrag, New MemoryStream()), MemoryStream).ToArray)
        TotalPageCount = reader.NumberOfPages
        CurrentPageCount = 1
        CreatePDF(auftrag, New FileStream(PathToSave, FileMode.Create))
        Process.Start(PathToSave)
        CheckBox5.IsChecked = prevstate
    End Sub

    Public Sub SaveSilent(auftrag As Order, PathToSave As String) Implements Biller.ICustomLayout.SaveSilent
        Dim prevstate As Boolean = CheckBox5.IsChecked
        If auftrag.Customer.IsCompany Then
            CheckBox5.IsChecked = True
        End If
        Dim reader As New PdfReader(DirectCast(CreatePDF(auftrag, New MemoryStream()), MemoryStream).ToArray)
        TotalPageCount = reader.NumberOfPages
        CurrentPageCount = 1
        CreatePDF(auftrag, New FileStream(PathToSave, FileMode.Create))
        CheckBox5.IsChecked = prevstate
    End Sub

    Public ReadOnly Property Version As Decimal Implements Biller.ICustomLayout.Version
        Get
            Return 2.2
        End Get
    End Property

    Public Property PageBreak As Boolean
    Public Property TotalPageCount As Integer
    Public Property CurrentPageCount As Integer

    Private Function CreatePDF(order As Order, stream As Stream) As Stream
        CurrentPageCount = 0
        PageBreak = False
        Dim document = New Document

        Dim dc2 = New Document
        Dim writer2 = PdfWriter.GetInstance(dc2, New MemoryStream)

        Dim activecolumns As Integer = 0
        Try
            writer = PdfWriter.GetInstance(document, stream)
        Catch ex As Exception
            Return Nothing
        End Try

        Dim fontname As String = GetSetting("Font")

        font_arial_15_bold = New Font(FontFactory.GetFont(fontname + " bold", CSng(GetSetting("FontSizeOrderID"))))
        font_arial_9 = New Font(FontFactory.GetFont(fontname, CSng(GetSetting("FontSizeContent"))))
        font_arial_9_bold = New Font(FontFactory.GetFont(fontname + " bold", CSng(GetSetting("FontSizeContent"))))


        document.AddTitle(order.DokumentArt.ToString + " Nr. " + order.OrderID.ToString)
        document.AddCreator("Biller")
        document.AddAuthor(_parentform.Database.LastCompany)
        document.SetMargins(cm_to_px(TryParseInt(GetSetting("Margin_Left"))), cm_to_px(TryParseInt(GetSetting("Margin_Right"))), cm_to_px(TryParseInt(GetSetting("Margin_Top"))), cm_to_px(TryParseInt(GetSetting("Margin_Bottom"))))

        dc2.SetMargins(cm_to_px(TryParseInt(GetSetting("Margin_Left"))), cm_to_px(TryParseInt(GetSetting("Margin_Right"))), cm_to_px(TryParseInt(GetSetting("Margin_Top"))), cm_to_px(TryParseInt(GetSetting("Margin_Bottom"))))

        writer.PageEvent = New iTextPageTemplate(Me, xml)
        writer2.PageEvent = New PageBrakeHelper(Me, xml)

        _auftrag = order

        dc2.Open()
        document.Open()

        '### Zusätzlicher Auftragstext ###'
        If String.IsNullOrEmpty(order.TextBefore) = False Then
            document.Add(New Phrase(vbCrLf + order.TextBefore, font_arial_9))
            dc2.Add(New Phrase(vbCrLf + order.TextBefore, font_arial_9))
        End If

        Dim dt As New DataTable
        Dim table As PdfPTable = GetArticleTable(activecolumns, True, dt, document)
        Select Case _auftrag.DokumentArt
            Case Dokumentart.Rechnung
                dt = tbl_rechnung
            Case Dokumentart.Lieferschein
                dt = tbl_lieferschein
            Case Dokumentart.Angebot
                dt = tbl_angebot
            Case Dokumentart.Gutschrift
                dt = tbl_gutschrift
        End Select
        Dim artikelbeschreibung As Boolean = False

        For Each r As DataRow In dt.Rows
            If r("Active") = "True" Then
                If r("Name") = "Artikeltext" Then
                    artikelbeschreibung = True
                Else
                    table.AddCell(New Phrase(r("AngezeigterName") + vbCrLf + " ", font_arial_9))
                End If
            End If
        Next

        Dim regulararticles As New Collection(Of TaxClassMoneyModel)
        Dim supplementaryarticles As New Collection(Of TaxClassMoneyModel)

        Dim listnebenleistung As New Collection(Of OrderedArticle)
        Dim zwischensumme As New Money(0)

        '### Artikelauflistung ###'
        Dim p1 As IElement
        For Each art As OrderedArticle In order.OrderedArticles
            Try
                Dim cancel As Boolean = False
                Dim temp As New TaxClassMoneyModel With {.TaxClass = art.TaxClass}
                If art.ArticleCategory.ToLower.Contains(("Alle Kategorien").ToLower) OrElse art.ArticleCategory = "" Then
                    If regulararticles.Contains(temp) Then
                        temp = regulararticles(regulararticles.IndexOf(temp))
                    Else
                        temp.Value = New Money(0)
                        regulararticles.Add(temp)
                    End If
                Else
                    If art.ArticleCategory.ToLower.Contains(("Nebenleistung").ToLower) Then
                        cancel = True
                        If Not supplementaryarticles.Contains(temp) Then
                            temp.Value = New Money(0)
                            supplementaryarticles.Add(temp)
                        End If
                        listnebenleistung.Add(art)
                    End If
                End If


                'If steuersaetze.Contains(art.TaxClass.Name) = False AndAlso (String.IsNullOrEmpty(art.ArticleCategory) OrElse art.ArticleCategory.ToLower.Contains(("Alle Kategorien").ToLower)) Then
                '    steuersaetze.Add(art.TaxClass.Name)
                '    steuersaetzegesamtpreis.Add(0.0)
                'Else
                '    If art.ArticleCategory IsNot Nothing Then
                '        If steuersaetzenl.Contains(art.TaxClass.Name) = False AndAlso art.ArticleCategory.ToLower.Contains(("Nebenleistung").ToLower) Then
                '            steuersaetzenl.Add(art.TaxClass.Name)
                '            steuersaetzegesamtpreisnl.Add(0.0)
                '            listnebenleistung.Add(art)
                '            cancel = True
                '        End If
                '    End If
                'End If

                For Each r As DataRow In dt.Rows
                    If cancel Then
                        Exit For
                    End If
                    If r("Active") = "True" Then
                        If r("Name") = "Artikeltext" Then
                        Else
                            Dim item As String = r("Name")
                            Select Case item
                                Case "Artikelposition"
                                    p1 = New Phrase(art.OrderPosition.ToString("0"), font_arial_9)
                                Case "Menge und Einheit"
                                    p1 = New Phrase(Math.Round(art.OrderedAmount, 3).ToString(GetSetting("Unit_String_Format")) + " " + art.ArticleUnit.ShortName.ToString, font_arial_9)
                                Case "Artikelnummer"
                                    p1 = New Phrase(art.ArticleID, font_arial_9)
                                Case "Artikelbezeichnung"
                                    If art.OrderText IsNot "" AndAlso artikelbeschreibung Then
                                        p1 = New Phrase(art.ArticleDescription + vbCrLf + art.OrderText + vbCrLf + " ", font_arial_9)
                                    Else
                                        p1 = New Phrase(art.ArticleDescription + vbCrLf + " ", font_arial_9)
                                    End If
                                Case "Gewicht"
                                    p1 = New Phrase(Math.Round((art.ArticleWeight * art.OrderedAmount), 3).ToString("0.000") + " " + Unit.GetByName("Kilogramm", xml).ShortName, font_arial_9)
                                Case "Rabatt"
                                    p1 = New Phrase(art.OrderRebate.ToString("0.00") + " %", font_arial_9)
                                Case "Einzelpreis"
                                    If CheckBox5.IsChecked OrElse order.Customer.IsCompany OrElse CBool(GetSetting("AbroadInvoice")) Then
                                        p1 = New Phrase(art.NetValue.ToString, font_arial_9)
                                    Else
                                        p1 = New Phrase(art.GrossValue.ToString, font_arial_9)
                                    End If
                                Case "Steuersatz"
                                    p1 = New Phrase(art.TaxClass.TaxRate.ToString("0.00") + " %", font_arial_9)
                                Case "Gesamtpreis (Artikel)"
                                    Dim c1 As PdfPCell
                                    If CheckBox5.IsChecked OrElse CBool(GetSetting("AbroadInvoice")) Then
                                        c1 = New PdfPCell(New Phrase(art.NetOrderValue.ToString, font_arial_9))
                                        regulararticles(regulararticles.IndexOf(temp)).Value += art.NetOrderValue.Amount
                                        zwischensumme += art.NetOrderValue
                                    Else
                                        c1 = New PdfPCell(New Phrase(art.GrossOrderValue.ToString, font_arial_9))
                                        regulararticles(regulararticles.IndexOf(temp)).Value += art.GrossOrderValue.Amount
                                        zwischensumme += art.GrossOrderValue
                                    End If

                                    c1.HorizontalAlignment = Element.ALIGN_RIGHT
                                    p1 = c1
                            End Select
                            Try
                                table.AddCell(CType(p1, Phrase))
                            Catch ex As Exception
                                table.AddCell(CType(p1, PdfPCell))
                            End Try
                        End If
                    End If
                Next
            Catch ex As Exception
                Exit For
            End Try
        Next
        Dim ph1 As New Paragraph()
        Select Case GetSetting("Table_position")
            Case "0"
                ph1.Alignment = Element.ALIGN_LEFT
                table.HorizontalAlignment = Element.ALIGN_LEFT
                ph1.IndentationLeft = cm_to_px(GetSetting("MarginSideTable")) - document.LeftMargin
            Case "1"
                ph1.Alignment = Element.ALIGN_CENTER
                table.HorizontalAlignment = Element.ALIGN_CENTER
            Case "2"
                ph1.Alignment = Element.ALIGN_RIGHT
                table.HorizontalAlignment = Element.ALIGN_RIGHT
                ph1.IndentationRight = cm_to_px(GetSetting("MarginSideTable")) - document.RightMargin
        End Select
        ph1.Add(table)

        dc2.Add(ph1)

        '### Now just add to the temporary ###'
        PageBreak = False
        activecolumns = 0
        Dim table2 = GetArticleTable(activecolumns, False, dt, document)
        Dim elements = ArticleTableEnd(table2, order, zwischensumme, regulararticles, activecolumns, supplementaryarticles, listnebenleistung, dc2)
        For Each item In elements
            dc2.Add(item)
        Next

        If PageBreak Then
            document.Add(ph1)
            document.NewPage()
            For Each item In elements
                document.Add(item)
            Next
        Else
            document.Add(ph1)
            For Each item In elements
                document.Add(item)
            Next
        End If
        document.Close()
        Return stream
    End Function

    Private Class TaxClassMoneyModel
        Public Property TaxClass As TaxClass
        Public Property Value As Money
        Public Overrides Function Equals(obj As Object) As Boolean
            Return TaxClass.Equals(obj.TaxClass)
        End Function
    End Class
End Class

Public Class iTextPageTemplate
    Inherits PdfPageEventHelper

    Private _xml As IDatabase
    Private _parent As CustomLayout

    Public Overrides Sub OnStartPage(writer As PdfWriter, document As Document)
        If _parent.CurrentPageCount = 1 Then
            _parent.Header(_parent._auftrag, document)
        Else
            If _parent.GetSetting("InvoiceAddressOnlyOnFirstPage") Then
                _parent.SmallHeader(_parent._auftrag, document)
            Else
                _parent.Header(_parent._auftrag, document)
            End If
        End If
    End Sub

    Public Sub New(parent As CustomLayout, xml As IDatabase)
        _parent = parent
        _xml = xml
    End Sub

    Private Class TaxClassMoneyModel
        Public Property TaxClass As TaxClass
        Public Property Value As Money
        Public Overrides Function Equals(obj As Object) As Boolean
            Return TaxClass.Equals(obj)
        End Function
    End Class
End Class


Public Class PageBrakeHelper
    Inherits iTextPageTemplate

    Private _parent As CustomLayout

    Public Sub New(parent As CustomLayout, xml As IDatabase)
        MyBase.New(parent, xml)
        _parent = parent
    End Sub

    Public Overrides Sub OnStartPage(writer As PdfWriter, document As Document)
        _parent.CurrentPageCount += 1
        MyBase.OnStartPage(writer, document)
    End Sub

    Public Overrides Sub OnEndPage(writer As PdfWriter, document As Document)
        MyBase.OnEndPage(writer, document)
        _parent.PageBreak = True
    End Sub
End Class