﻿Imports System.Collections.ObjectModel
Imports System.Data
Imports System.Xml
Imports System.Threading.Tasks
Imports iTextSharp.text.pdf

Public Class CustomLayout
    Private tbl_rechnung As DataTable
    Private tbl_lieferschein As DataTable
    Private tbl_angebot As DataTable
    Private tbl_gutschrift As DataTable

    WithEvents _parentform As Biller.Window1
    Private settings As Xml.XmlDocument
    Public Sub New(ByVal MainForm As Biller.Window1)
        ' Dieser Aufruf ist für den Designer erforderlich.
        InitializeComponent()
        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        _parentform = MainForm
        xml = MainForm.Database
        settings = New Xml.XmlDocument()
        InitializeConfigFile(System.AppDomain.CurrentDomain.BaseDirectory() + "\Firma\" + xml.LastCompany + "\Layoutsettings.xml")


        For Each fontFamily As FontFamily In System.Windows.Media.Fonts.SystemFontFamilies
            'FontFamily.Source contains the font family name.
            ComboBox1.Items.Add(fontFamily.Source)
        Next fontFamily

        LoadPreferences()

        Dim t1 As Task = Task.Factory.StartNew(Sub()
                                                   iTextSharp.text.FontFactory.RegisterDirectory("C:\Windows\Fonts")
                                               End Sub)
        _parentform.AddNewLicense("iTextSharp (PDF)", "Affere General Public License (AGPL)", My.Resources.agpl)
        _parentform.UpdateChecker.AddFile(New FuncClasses.UpdateFileInfo("Standardlayout.layout", GetUIString("UpdaterInfoText"), Version))
    End Sub

    Private Sub LoadPreferences() Handles _parentform.CompanyChanged
        InitializeConfigFile(System.AppDomain.CurrentDomain.BaseDirectory() + "\Firma\" + xml.LastCompany + "\Layoutsettings.xml")
        settings.Load(System.AppDomain.CurrentDomain.BaseDirectory() + "\Firma\" + xml.LastCompany + "\Layoutsettings.xml")

        'Einstellungen laden
        If String.IsNullOrEmpty(GetSetting("PDF_Briefpapier")) = True Then
            RadioButton4.IsChecked = True
        Else
            TextBox8.Text = GetSetting("PDF_Briefpapier")
            RadioButton5.IsChecked = True
        End If

        If String.IsNullOrEmpty(GetSetting("Font")) Then
            ComboBox1.SelectedItem = "Arial"
            SaveSetting("Font", "Arial")
        Else
            ComboBox1.SelectedItem = GetSetting("Font")
        End If

        If String.IsNullOrEmpty(GetSetting("Margin_Top")) Then
            SaveSetting("Margin_Top", "1,27")
            TextBox1.Text = "1,27"
        Else
            TextBox1.Text = GetSetting("Margin_Top")
        End If

        If String.IsNullOrEmpty(GetSetting("Margin_Right")) Then
            SaveSetting("Margin_Right", "1,27")
            TextBox2.Text = "1,27"
        Else
            TextBox2.Text = GetSetting("Margin_Right")
        End If

        If String.IsNullOrEmpty(GetSetting("Margin_Bottom")) Then
            SaveSetting("Margin_Bottom", "1,27")
            TextBox3.Text = "1,27"
        Else
            TextBox3.Text = GetSetting("Margin_Bottom")
        End If

        If String.IsNullOrEmpty(GetSetting("Margin_Left")) Then
            SaveSetting("Margin_Left", "1,27")
            TextBox4.Text = "1,27"
        Else
            TextBox4.Text = GetSetting("Margin_Left")
        End If

        Try
            CheckBox1.IsChecked = CBool(GetSetting("Print_sender"))
            TextBox5.IsEnabled = CBool(GetSetting("Print_sender"))
            TextBox11.IsEnabled = TextBox5.IsEnabled
            TextBox12.IsEnabled = TextBox5.IsEnabled
        Catch ex As Exception
            SaveSetting("Print_sender", False)
        End Try
        If String.IsNullOrEmpty(GetSetting("Margin_Sender_Left")) = False Then
            TextBox5.Text = GetSetting("Margin_Sender_Left")
        Else
            SaveSetting("Margin_Sender_Left", "1,8")
            TextBox5.Text = "1,8"
        End If

        If String.IsNullOrEmpty(GetSetting("Margin_receiver")) Then
            SaveSetting("Margin_receiver", "2,4")
            TextBox6.Text = "2,4"
        Else
            TextBox6.Text = GetSetting("Margin_receiver")
        End If

        Try
            CheckBox2.IsChecked = CBool(GetSetting("Receiver_freeSpace"))
        Catch ex As Exception
            SaveSetting("Receiver_freeSpace", "True")
            CheckBox2.IsChecked = True
        End Try

        If String.IsNullOrEmpty(GetSetting("Table_position")) Then
            RadioButton2.IsChecked = True
            SaveSetting("Table_position", 1)
        Else
            Select Case GetSetting("Table_position")
                Case "0"
                    RadioButton1.IsChecked = True
                Case "1"
                    RadioButton2.IsChecked = True
                Case "2"
                    RadioButton3.IsChecked = True
            End Select
        End If

        If String.IsNullOrEmpty(GetSetting("Table_width")) Then
            SaveSetting("Table_width", "18")
            TextBox7.Text = "18"
        Else
            TextBox7.Text = GetSetting("Table_width")
        End If

        Try
            CheckBox3.IsChecked = CBool(GetSetting("Minus_abzgl"))
        Catch ex As Exception
            SaveSetting("Minus_abzgl", False)
            CheckBox3.IsChecked = False
        End Try

        InitializeDataTables()

        Try
            tbl_rechnung = GetDataTable("Rechnung")
        Catch ex As Exception : End Try
        Try
            tbl_lieferschein = GetDataTable("Lieferschein")
        Catch ex As Exception : End Try
        Try
            tbl_angebot = GetDataTable("Angebot")
        Catch ex As Exception : End Try
        Try
            tbl_gutschrift = GetDataTable("Gutschrift")
        Catch ex As Exception : End Try
        ComboBox2.SelectedIndex = 0


        If String.IsNullOrEmpty(GetSetting("Margin_Sender_Top")) = False Then
            TextBox11.Text = GetSetting("Margin_Sender_Top")
        Else
            SaveSetting("Margin_Sender_Top", "0")
            TextBox11.Text = "0"
        End If

        If String.IsNullOrEmpty(GetSetting("Margin_Sender_Bottom")) = False Then
            TextBox12.Text = GetSetting("Margin_Sender_Bottom")
        Else
            SaveSetting("Margin_Sender_Bottom", "0,5")
            TextBox12.Text = "0,5"
        End If

        If String.IsNullOrEmpty(GetSetting("Margin_Receiver_Top")) = False Then
            TextBox13.Text = GetSetting("Margin_Receiver_Top")
        Else
            SaveSetting("Margin_Receiver_Top", "0")
            TextBox13.Text = "0"
        End If

        If String.IsNullOrEmpty(GetSetting("Margin_Receiver_Bottom")) = False Then
            TextBox14.Text = GetSetting("Margin_Receiver_Bottom")
        Else
            SaveSetting("Margin_Receiver_Bottom", "0")
            TextBox14.Text = "0"
        End If

        If String.IsNullOrEmpty(GetSetting("Margin_Table_Top")) = False Then
            TextBox15.Text = GetSetting("Margin_Table_Top")
        Else
            SaveSetting("Margin_Table_Top", "0")
            TextBox15.Text = "0"
        End If

        If String.IsNullOrEmpty(GetSetting("Margin_Table_Bottom")) = False Then
            TextBox16.Text = GetSetting("Margin_Table_Bottom")
        Else
            SaveSetting("Margin_Table_Bottom", "0")
            TextBox16.Text = "0"
        End If

        If String.IsNullOrEmpty(GetSetting("Alignment_Date")) = False Then
            Select Case GetSetting("Alignment_Date")
                Case "Left"
                    RadioButton6.IsChecked = True
                Case "Right"
                    RadioButton8.IsChecked = True
            End Select
        Else
            SaveSetting("Alignment_Date", "Right")
            RadioButton8.IsChecked = True
        End If

        If String.IsNullOrEmpty(GetSetting("Margin_Date_Top")) = False Then
            TextBox18.Text = GetSetting("Margin_Date_Top")
        Else
            SaveSetting("Margin_Date_Top", "0")
            TextBox18.Text = "0"
        End If

        If String.IsNullOrEmpty(GetSetting("Margin_Date_Bottom")) = False Then
            TextBox19.Text = GetSetting("Margin_Date_Bottom")
        Else
            SaveSetting("Margin_Date_Bottom", "0")
            TextBox19.Text = "0"
        End If

        If String.IsNullOrEmpty(GetSetting("Margin_Date_Side")) = False Then
            TextBox17.Text = GetSetting("Margin_Date_Side")
        Else
            SaveSetting("Margin_Date_Side", "1,27")
            TextBox17.Text = "1,27"
        End If

        If String.IsNullOrEmpty(GetSetting("DeliveryAddress_On_Delivery")) = False Then
            CheckBox4.IsChecked = CBool(GetSetting("DeliveryAddress_On_Delivery"))
        Else
            CheckBox4.IsChecked = True
        End If

        If String.IsNullOrEmpty(GetSetting("OrderGrossValues")) = False Then
            CheckBox5.IsChecked = CBool(GetSetting("OrderGrossValues"))
        Else
            CheckBox5.IsChecked = False
        End If

        If String.IsNullOrEmpty(GetSetting("NoTaxes")) = False Then
            CheckBox7.IsChecked = CBool(GetSetting("NoTaxes"))
        Else
            CheckBox7.IsChecked = False
            SaveSetting("NoTaxes", CheckBox7.IsChecked)
        End If

        If String.IsNullOrEmpty(GetSetting("MarginLeftDocumentNumber")) = False Then
            TextBox21.Text = (GetSetting("MarginLeftDocumentNumber"))
        Else
            TextBox21.Text = "1,8"
        End If

        If String.IsNullOrEmpty(GetSetting("MarginTopDocumentNumber")) = False Then
            TextBox22.Text = (GetSetting("MarginTopDocumentNumber"))
        Else
            TextBox22.Text = "0,7"
        End If

        If String.IsNullOrEmpty(GetSetting("MarginBotDocumentNumber")) = False Then
            TextBox23.Text = (GetSetting("MarginBotDocumentNumber"))
        Else
            TextBox23.Text = "0"
        End If
        If String.IsNullOrEmpty(GetSetting("MarginSideTable")) = False Then
            TextBox24.Text = (GetSetting("MarginSideTable"))
        Else
            TextBox24.Text = "0"
        End If

        If Not String.IsNullOrEmpty(GetSetting("ShowUserName")) Then
            CheckBox8.IsChecked = CBool(GetSetting("ShowUserName"))
        Else
            SaveSetting("ShowUserName", False)
            CheckBox8.IsChecked = False
        End If

        If Not String.IsNullOrEmpty(GetSetting("ShowUserID")) Then
            CheckBox9.IsChecked = CBool(GetSetting("ShowUserID"))
        Else
            SaveSetting("ShowUserID", False)
            CheckBox9.IsChecked = False
        End If

        If Not String.IsNullOrEmpty(GetSetting("FontSizeContent")) Then
            tb_fontSizeContent.Text = GetSetting("FontSizeContent")
        Else
            tb_fontSizeContent.Text = 9
            SaveSetting("FontSizeContent", 9)
        End If

        If Not String.IsNullOrEmpty(GetSetting("FontSizeOrderID")) Then
            tb_fontSizeOrderID.Text = GetSetting("FontSizeOrderID")
        Else
            tb_fontSizeOrderID.Text = 12
            SaveSetting("FontSizeOrderID", 12)
        End If

        If Not String.IsNullOrEmpty(GetSetting("InvoiceAddressOnlyOnFirstPage")) Then
            CheckBox6.IsChecked = GetSetting("InvoiceAddressOnlyOnFirstPage")
        Else
            SaveSetting("InvoiceAddressOnlyOnFirstPage", False)
            CheckBox6.IsChecked = False
        End If

        If Not String.IsNullOrEmpty(GetSetting("ShowPageCount")) Then
            CheckBox10.IsChecked = GetSetting("ShowPageCount")
        Else
            SaveSetting("ShowPageCount", False)
            CheckBox10.IsChecked = False
        End If

        If Not String.IsNullOrEmpty(GetSetting("ShowContactPerson")) Then
            CB_ShowContactPerson.IsChecked = GetSetting("ShowContactPerson")
        Else
            SaveSetting("ShowContactPerson", False)
            CB_ShowContactPerson.IsChecked = False
        End If

        If Not String.IsNullOrEmpty(GetSetting("AbroadInvoice")) Then
            CheckBox11.IsChecked = GetSetting("AbroadInvoice")
        Else
            SaveSetting("AbroadInvoice", False)
            CheckBox11.IsChecked = False
        End If
    End Sub

    Private Sub InitializeDataTables()
        tbl_rechnung = New DataTable("Rechnung")
        tbl_rechnung.Columns.Add("Name")
        tbl_rechnung.Columns.Add("AngezeigterName")
        tbl_rechnung.Columns.Add("Breite")
        tbl_rechnung.Columns.Add("Active")
        tbl_rechnung.Rows.Add(GetUIString("DTArticlePosition"), GetUIString("DTArticlePositionV"), "1", True)
        tbl_rechnung.Rows.Add(GetUIString("DTAmountAndUnit"), GetUIString("DTAmountAndUnitV"), "2", True)
        tbl_rechnung.Rows.Add(GetUIString("DTArticleNo"), GetUIString("DTArticleNoV"), "1,6", True)
        tbl_rechnung.Rows.Add(GetUIString("DTArticleName"), GetUIString("DTArticleNameV"), "6,8", True)
        tbl_rechnung.Rows.Add(GetUIString("DTArticleText"), GetUIString("DTArticleTextV"), "", True)
        tbl_rechnung.Rows.Add(GetUIString("DTWeight"), GetUIString("DTWeightV"), "2", False)
        tbl_rechnung.Rows.Add(GetUIString("DTSinglePrice"), GetUIString("DTSinglePriceV"), "2", True)
        tbl_rechnung.Rows.Add(GetUIString("DTDiscount"), GetUIString("DTDiscountV"), "1,7", False)
        tbl_rechnung.Rows.Add(GetUIString("DTTaxRate"), GetUIString("DTTaxRateV"), "1,7", True)
        tbl_rechnung.Rows.Add(GetUIString("DTTotalPriceArticle"), GetUIString("DTTotalPriceArticleV"), "2,2", True)

        tbl_lieferschein = New DataTable("Lieferschein")
        tbl_lieferschein.Columns.Add("Name")
        tbl_lieferschein.Columns.Add("AngezeigterName")
        tbl_lieferschein.Columns.Add("Breite")
        tbl_lieferschein.Columns.Add("Active")
        tbl_lieferschein.Rows.Add(GetUIString("DTArticlePosition"), GetUIString("DTArticlePositionV"), "1,8", True)
        tbl_lieferschein.Rows.Add(GetUIString("DTAmountAndUnit"), GetUIString("DTAmountAndUnitV"), "2,6", True)
        tbl_lieferschein.Rows.Add(GetUIString("DTArticleNo"), GetUIString("DTArticleNoV"), "1,4", True)
        tbl_lieferschein.Rows.Add(GetUIString("DTArticleName"), GetUIString("DTArticleNameV"), "6,8", True)
        tbl_lieferschein.Rows.Add(GetUIString("DTArticleText"), GetUIString("DTArticleTextV"), "", True)
        tbl_lieferschein.Rows.Add(GetUIString("DTWeight"), GetUIString("DTWeightV"), "2", True)
        tbl_lieferschein.Rows.Add(GetUIString("DTSinglePrice"), GetUIString("DTSinglePriceV"), "2", False)
        tbl_lieferschein.Rows.Add(GetUIString("DTDiscount"), GetUIString("DTDiscountV"), "1,7", False)
        tbl_lieferschein.Rows.Add(GetUIString("DTTaxRate"), GetUIString("DTTaxRateV"), "1,7", False)
        tbl_lieferschein.Rows.Add(GetUIString("DTTotalPriceArticle"), GetUIString("DTTotalPriceArticleV"), "2,2", False)

        tbl_angebot = New DataTable("Angebot")
        tbl_angebot.Columns.Add("Name")
        tbl_angebot.Columns.Add("AngezeigterName")
        tbl_angebot.Columns.Add("Breite")
        tbl_angebot.Columns.Add("Active")
        tbl_angebot.Rows.Add(GetUIString("DTArticlePosition"), GetUIString("DTArticlePositionV"), "1,8", True)
        tbl_angebot.Rows.Add(GetUIString("DTAmountAndUnit"), GetUIString("DTAmountAndUnitV"), "2,6", True)
        tbl_angebot.Rows.Add(GetUIString("DTArticleNo"), GetUIString("DTArticleNoV"), "1,4", True)
        tbl_angebot.Rows.Add(GetUIString("DTArticleName"), GetUIString("DTArticleNameV"), "6,8", True)
        tbl_angebot.Rows.Add(GetUIString("DTArticleText"), GetUIString("DTArticleTextV"), "", True)
        tbl_angebot.Rows.Add(GetUIString("DTWeight"), GetUIString("DTWeightV"), "2", False)
        tbl_angebot.Rows.Add(GetUIString("DTSinglePrice"), GetUIString("DTSinglePriceV"), "2", True)
        tbl_angebot.Rows.Add(GetUIString("DTDiscount"), GetUIString("DTDiscountV"), "1,7", True)
        tbl_angebot.Rows.Add(GetUIString("DTTaxRate"), GetUIString("DTTaxRateV"), "1,7", True)
        tbl_angebot.Rows.Add(GetUIString("DTTotalPriceArticle"), GetUIString("DTTotalPriceArticleV"), "2,2", True)

        tbl_gutschrift = New DataTable("Gutschrift")
        tbl_gutschrift.Columns.Add("Name")
        tbl_gutschrift.Columns.Add("AngezeigterName")
        tbl_gutschrift.Columns.Add("Breite")
        tbl_gutschrift.Columns.Add("Active")
        tbl_gutschrift.Rows.Add(GetUIString("DTArticlePosition"), GetUIString("DTArticlePositionV"), "1,8", True)
        tbl_gutschrift.Rows.Add(GetUIString("DTAmountAndUnit"), GetUIString("DTAmountAndUnitV"), "2,6", True)
        tbl_gutschrift.Rows.Add(GetUIString("DTArticleNo"), GetUIString("DTArticleNoV"), "1,4", True)
        tbl_gutschrift.Rows.Add(GetUIString("DTArticleName"), GetUIString("DTArticleNameV"), "6,8", True)
        tbl_gutschrift.Rows.Add(GetUIString("DTArticleText"), GetUIString("DTArticleTextV"), "", True)
        tbl_gutschrift.Rows.Add(GetUIString("DTWeight"), GetUIString("DTWeightV"), "2", False)
        tbl_gutschrift.Rows.Add(GetUIString("DTSinglePrice"), GetUIString("DTSinglePriceV"), "2", True)
        tbl_gutschrift.Rows.Add(GetUIString("DTDiscount"), GetUIString("DTDiscountV"), "1,7", True)
        tbl_gutschrift.Rows.Add(GetUIString("DTTaxRate"), GetUIString("DTTaxRateV"), "1,7", True)
        tbl_gutschrift.Rows.Add(GetUIString("DTTotalPriceArticle"), GetUIString("DTTotalPriceArticleV"), "2,2", True)
    End Sub

    Private Sub SaveSettings() Handles _parentform.SaveLayoutSettings
        SaveXML()
    End Sub

#Region "XML Settings"
    Private Sub InitializeConfigFile(ByVal path As String)
        'if the file doesn't exist, create a blank xml
        Dim dir As String = Mid(path, 1, path.LastIndexOf("\"))
        If Not IO.Directory.Exists(dir) Then
            IO.Directory.CreateDirectory(dir)
        End If
        If Not IO.File.Exists(path) Then
            Dim fn As New IO.StreamWriter(IO.File.Open(path, IO.FileMode.Create))
            fn.WriteLine("<?xml version=""1.0"" encoding=""utf-8""?>")
            fn.WriteLine("<LayoutConfiguration>")
            fn.WriteLine("  <Standardlayout>")
            fn.WriteLine("  </Standardlayout>")
            fn.WriteLine("</LayoutConfiguration>")
            fn.Close() 'all done
        End If
    End Sub

    Public Sub SaveSetting(ByVal key As String, ByVal value As String)
        'xml
        Try
            'get the value
            Dim Node As Xml.XmlElement = CType(settings.DocumentElement.SelectSingleNode( _
                                               "/LayoutConfiguration/Standardlayout/setting[@key=""" & _
                                               key & """]"), Xml.XmlElement)
            If Not Node Is Nothing Then
                'key found, set the value
                Node.Attributes.GetNamedItem("value").Value = value
            Else
                'key not found, create it
                Node = settings.CreateElement("setting")
                Node.SetAttribute("key", key)
                Node.SetAttribute("value", value)

                'look for the appsettings node
                Dim Root As Xml.XmlNode = settings.DocumentElement.SelectSingleNode("/LayoutConfiguration/Standardlayout")

                'add the new child node (this key)
                If Not Root Is Nothing Then
                    Root.AppendChild(Node)
                Else
                    Try
                        'appsettings node didn't exist, add it before adding the new child
                        Root = settings.DocumentElement.SelectSingleNode("/LayoutConfiguration")
                        Root.AppendChild(settings.CreateElement("Standardlayout"))
                        Root = settings.DocumentElement.SelectSingleNode("/LayoutConfiguration/Standardlayout")
                        Root.AppendChild(Node)
                    Catch ex As Exception
                        'failed adding node, throw an error
                        Throw New Exception("Could not set value for Standardlayout", ex)
                    End Try
                End If
            End If
        Catch ex As Exception

        End Try
        SaveXML()
    End Sub

    Public Function GetSetting(ByVal key As String) As String
        'query for a value
        Dim Node As Xml.XmlNode = settings.DocumentElement.SelectSingleNode( _
                                  "/LayoutConfiguration/Standardlayout/setting[@key=""" & key & """]")

        'return the value or nothing if it doesn't exist
        If Not Node Is Nothing Then
            Return Node.Attributes.GetNamedItem("value").Value
        Else
            Return Nothing
        End If
    End Function

    Private Sub SaveDataTable(ByVal table As DataTable)
        Dim Node As Xml.XmlElement = CType(settings.DocumentElement.SelectSingleNode( _
                                              "/LayoutConfiguration/Standardlayout/" + table.TableName), Xml.XmlElement)
        If Not Node Is Nothing Then
            'XML Schlüssel existiert
            For Each row As DataRow In table.Rows
                Dim item As Xml.XmlElement = CType(settings.DocumentElement.SelectSingleNode("/LayoutConfiguration/Standardlayout/" + table.TableName + "[@Name=""" & row(0) & """]"), Xml.XmlElement)
                item.Attributes.GetNamedItem("Name").Value = row(0)
                item.Attributes.GetNamedItem("AngezeigterName").Value = row(1)
                item.Attributes.GetNamedItem("Breite").Value = row(2)
                item.Attributes.GetNamedItem("Active").Value = row(3)
            Next
        Else
            'XML Schlüssel existiert nicht

            Dim col As New Collection(Of XmlElement)
            For Each row As DataRow In table.Rows
                Node = settings.CreateElement(table.TableName)
                'Dim item As Xml.XmlElement = settings.CreateElement("setting")
                Node.SetAttribute("Name", row(0))
                Node.SetAttribute("AngezeigterName", row(1))
                Node.SetAttribute("Breite", row(2))
                Node.SetAttribute("Active", row(3))
                col.Add(Node)
            Next

            'look for the appsettings node
            Dim Root As Xml.XmlNode = settings.DocumentElement.SelectSingleNode("/LayoutConfiguration/Standardlayout")

            'add the new child node (this key)
            If Not Root Is Nothing Then
                For Each n As XmlElement In col
                    Root.AppendChild(n)
                Next
            Else
                Try
                    'appsettings node didn't exist, add it before adding the new child
                    Root = settings.DocumentElement.SelectSingleNode("/LayoutConfiguration")
                    Root.AppendChild(settings.CreateElement("Standardlayout"))
                    Root = settings.DocumentElement.SelectSingleNode("/LayoutConfiguration/Standardlayout")
                    Root.AppendChild(Node)
                Catch ex As Exception
                    'failed adding node, throw an error
                    Throw New Exception("Could not set DataTable for Standardlayout", ex)
                End Try
            End If
        End If
        SaveXML()
    End Sub

    Private Function GetDataTable(ByVal MainKeyName As String) As DataTable
        Dim temp As New DataTable(MainKeyName)
        temp.Columns.Add("Name")
        temp.Columns.Add("AngezeigterName")
        temp.Columns.Add("Breite")
        temp.Columns.Add("Active")

        Dim root As XmlElement = CType(settings.DocumentElement.SelectSingleNode("/LayoutConfiguration/Standardlayout"), Xml.XmlElement)
        Dim nodeList As XmlNodeList = root.GetElementsByTagName(MainKeyName)
        Dim list As IEnumerator = nodeList.GetEnumerator

        Do While (list.MoveNext())
            Dim item As XmlElement
            item = CType(list.Current, XmlElement)
            temp.Rows.Add(item.Attributes.GetNamedItem("Name").Value, item.Attributes.GetNamedItem("AngezeigterName").Value, item.Attributes.GetNamedItem("Breite").Value, item.Attributes.GetNamedItem("Active").Value)
        Loop

        If temp.Rows.Count > 0 Then : Return temp
        Else : Throw New Exception("Nicht vorhanden")
        End If
    End Function

    ''' <summary>
    ''' Deletes a node by Keyname
    ''' </summary>
    ''' <param name="key">Name of the Key you wan't to delete</param>
    ''' <remarks></remarks>
    Public Sub DeleteSetting(ByVal key As String)

        'query for a value
        Dim Node As Xml.XmlNode = settings.DocumentElement.SelectSingleNode( _
                                  "/LayoutConfiguration/Standardlayout/setting[@key=""" & key & """]")

        'return the value or nothing if it doesn't exist
        Try
            Node.RemoveAll()
        Catch ex As Exception : End Try
    End Sub

    ''' <summary>
    ''' Saves the current Settings
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub SaveXML()
        settings.Save(System.AppDomain.CurrentDomain.BaseDirectory() + "\Firma\" + xml.LastCompany + "\Layoutsettings.xml")
    End Sub
#End Region

    ''' <summary>
    ''' Briefpapier
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button4.Click
        Dim dlg As New Microsoft.Win32.OpenFileDialog()
        dlg.DefaultExt = ".pdf" ' Default file extension
        dlg.Filter = GetUIString("FDFilter") ' Filter files by extension
        dlg.Title = GetUIString("FDTitle")
        ' Show open file dialog box
        Dim result? As Boolean = dlg.ShowDialog()

        ' Process open file dialog box results
        If result = True Then
            SaveSetting("PDF_Briefpapier", dlg.FileName)
            TextBox8.Text = dlg.FileName
        Else
            DeleteSetting("PDF_Briefpapier")
        End If
    End Sub

    ''' <summary>
    ''' Briefpapier Radiobutton
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RadioButton5_Checked(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles RadioButton5.Checked
        Button4.IsEnabled = True
        TextBox8.IsEnabled = True
        SaveSetting("PDF_Briefpapier", TextBox8.Text)
    End Sub

    ''' <summary>
    ''' Kein Briefpapier Radiobutton
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RadioButton4_Checked(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles RadioButton4.Checked
        Button4.IsEnabled = False
        TextBox8.IsEnabled = False
        DeleteSetting("PDF_Briefpapier")
    End Sub

    ''' <summary>
    ''' Font to Print
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ComboBox1_SelectionChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs) Handles ComboBox1.SelectionChanged
        SaveSetting("Font", ComboBox1.SelectedValue)
    End Sub

    ''' <summary>
    ''' Seitenrand Oben
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox1.TextChanged
        SaveSetting("Margin_Top", TextBox1.Text)
    End Sub

    ''' <summary>
    ''' Seitenrand Unten
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox3_TextChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox3.TextChanged
        SaveSetting("Margin_Bottom", TextBox3.Text)
    End Sub

    ''' <summary>
    ''' Seitenrand Rechts
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox2_TextChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox2.TextChanged
        SaveSetting("Margin_Right", TextBox2.Text)
    End Sub

    ''' <summary>
    ''' Seitenrand Links
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox4_TextChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox4.TextChanged
        SaveSetting("Margin_Left", TextBox4.Text)
    End Sub

    ''' <summary>
    ''' Absender drucken
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CheckBox1_Checked(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles CheckBox1.Checked
        TextBox5.IsEnabled = True
        TextBox11.IsEnabled = True
        TextBox12.IsEnabled = True
        SaveSetting("Print_sender", True)
    End Sub

    ''' <summary>
    ''' Absender nicht drucken
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CheckBox1_UnChecked(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles CheckBox1.Unchecked
        TextBox5.IsEnabled = False
        TextBox11.IsEnabled = False
        TextBox12.IsEnabled = False
        SaveSetting("Print_sender", False)
        DeleteSetting("Margin_Sender_Right")
    End Sub

    ''' <summary>
    ''' Seitenabstand Absender
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox5_TextChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox5.TextChanged
        SaveSetting("Margin_Sender_Left", TextBox5.Text)
    End Sub

    ''' <summary>
    ''' Seitenabstand Empfänger
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox6_TextChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox6.TextChanged
        SaveSetting("Margin_receiver", TextBox6.Text)
    End Sub

    ''' <summary>
    ''' Leerzeile Empfänger
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CheckBox2_Checked(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles CheckBox2.Checked
        SaveSetting("Receiver_freeSpace", True)

        Dim img As New BitmapImage()
        img.BeginInit()
        img.UriSource = New Uri("pack://application:,,,/Standardlayout;component/Icon/pic6.png")
        img.EndInit()

        _parentform.Dispatcher.BeginInvoke(Sub()
                                               _parentform.LayoutImageControl.Stretch = Stretch.Uniform
                                               _parentform.LayoutImageControl.Source = img
                                           End Sub)
    End Sub

    ''' <summary>
    ''' Kein Leerzeile Empfänger
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CheckBox2_Unchecked(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles CheckBox2.Unchecked
        SaveSetting("Receiver_freeSpace", False)

        Dim img As New BitmapImage()
        img.BeginInit()
        img.UriSource = New Uri("pack://application:,,,/Standardlayout;component/Icon/pic5.png")
        img.EndInit()

        _parentform.Dispatcher.BeginInvoke(Sub()
                                               _parentform.LayoutImageControl.Stretch = Stretch.Uniform
                                               _parentform.LayoutImageControl.Source = img
                                           End Sub)
    End Sub

    ''' <summary>
    ''' Tabelle Linksbündig
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RadioButton1_Checked(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles RadioButton1.Checked
        SaveSetting("Table_position", 0)
        TextBox24.IsEnabled = True
    End Sub

    ''' <summary>
    ''' Tabelle Zentriert
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RadioButton2_Checked(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles RadioButton2.Checked
        SaveSetting("Table_position", 1)
        TextBox24.IsEnabled = False
    End Sub

    ''' <summary>
    ''' Tabelle Rechtsbündig
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RadioButton3_Checked(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles RadioButton3.Checked
        SaveSetting("Table_position", 2)
        TextBox24.IsEnabled = True
    End Sub

    ''' <summary>
    ''' Tabellenbreite
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox7_TextChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox7.TextChanged
        SaveSetting("Table_width", TextBox7.Text)
    End Sub

    ''' <summary>
    ''' Minuszeichen bei abzüglichen Beträgen
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CheckBox3_Checked_1(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles CheckBox3.Checked
        SaveSetting("Minus_abzgl", True)
    End Sub

    ''' <summary>
    ''' Minuszeichen bei abzüglichen Beträgen
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CheckBox3_UnChecked_1(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles CheckBox3.Unchecked
        SaveSetting("Minus_abzgl", False)
    End Sub

    Private Sub CheckBox3_Checked(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Dim cb As CheckBox
        Try
            cb = CType(sender, CheckBox)
        Catch ex As Exception
            Exit Sub
        End Try

        If ListView1.SelectedItems.Count = 1 AndAlso ListView1.SelectedItem.Equals(cb.DataContext) Then
            'Dim row As DataRow 'View
            If ComboBox2.SelectedIndex = 0 Then
                tbl_rechnung.Rows(ListView1.SelectedIndex).Item("Active") = "True"
            End If
            If ComboBox2.SelectedIndex = 1 Then
                tbl_lieferschein.Rows(ListView1.SelectedIndex).Item("Active") = "True"
            End If
            If ComboBox2.SelectedIndex = 2 Then
                tbl_angebot.Rows(ListView1.SelectedIndex).Item("Active") = "True"
            End If
            If ComboBox2.SelectedIndex = 3 Then
                tbl_gutschrift.Rows(ListView1.SelectedIndex).Item("Active") = "True"
            End If
            SaveDataTable(ListView1.DataContext)
        Else
            Try
                ListView1.SelectedItem = cb.DataContext
                If ComboBox2.SelectedIndex = 0 Then
                    tbl_rechnung.Rows(ListView1.SelectedIndex).Item("Active") = "True"
                End If
                If ComboBox2.SelectedIndex = 1 Then
                    tbl_lieferschein.Rows(ListView1.SelectedIndex).Item("Active") = "True"
                End If
                If ComboBox2.SelectedIndex = 2 Then
                    tbl_angebot.Rows(ListView1.SelectedIndex).Item("Active") = "True"
                End If
                If ComboBox2.SelectedIndex = 3 Then
                    tbl_gutschrift.Rows(ListView1.SelectedIndex).Item("Active") = "True"
                End If
                SaveDataTable(ListView1.DataContext)
            Catch ex As Exception

            End Try
        End If
    End Sub

    Private Sub CheckBox3_Unchecked(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Dim cb As CheckBox
        Try
            cb = CType(sender, CheckBox)
        Catch ex As Exception
            Exit Sub
        End Try
        If ListView1.SelectedItems.Count = 1 AndAlso ListView1.SelectedItem.Equals(cb.DataContext) Then
            If ComboBox2.SelectedIndex = 0 Then
                tbl_rechnung.Rows(ListView1.SelectedIndex).Item("Active") = "False"
            End If
            If ComboBox2.SelectedIndex = 1 Then
                tbl_lieferschein.Rows(ListView1.SelectedIndex).Item("Active") = "False"
            End If
            If ComboBox2.SelectedIndex = 2 Then
                tbl_angebot.Rows(ListView1.SelectedIndex).Item("Active") = "False"
            End If
            If ComboBox2.SelectedIndex = 3 Then
                tbl_gutschrift.Rows(ListView1.SelectedIndex).Item("Active") = "False"
            End If
            SaveDataTable(ListView1.DataContext)
        Else
            Try
                ListView1.SelectedItem = cb.DataContext
                If ComboBox2.SelectedIndex = 0 Then
                    tbl_rechnung.Rows(ListView1.SelectedIndex).Item("Active") = "False"
                End If
                If ComboBox2.SelectedIndex = 1 Then
                    tbl_lieferschein.Rows(ListView1.SelectedIndex).Item("Active") = "False"
                End If
                If ComboBox2.SelectedIndex = 2 Then
                    tbl_angebot.Rows(ListView1.SelectedIndex).Item("Active") = "False"
                End If
                If ComboBox2.SelectedIndex = 3 Then
                    tbl_gutschrift.Rows(ListView1.SelectedIndex).Item("Active") = "False"
                End If
                SaveDataTable(ListView1.DataContext)
            Catch ex As Exception

            End Try
        End If

    End Sub

    Private Sub ListView1_SelectionChanged(sender As System.Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles ListView1.SelectionChanged
        If ListView1.SelectedItems.Count = 1 Then
            Dim row As DataRowView = ListView1.SelectedItem
            TextBox9.Text = row.Row("AngezeigterName")
            TextBox10.Text = row.Row("Breite")
        End If
        If ListView1.SelectedIndex = 0 Then
            Button2.IsEnabled = False
        Else
            Button2.IsEnabled = True
        End If
        If ListView1.SelectedIndex = ListView1.Items.Count - 1 Then
            Button3.IsEnabled = False
        Else
            Button3.IsEnabled = True
        End If
    End Sub

    Private Sub TextBox9_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox9.TextChanged
        If ListView1.SelectedItems.Count = 1 Then
            Dim row As DataRowView = ListView1.SelectedItem
            row.Row("AngezeigterName") = TextBox9.Text
            SaveDataTable(ListView1.DataContext)
        End If
    End Sub

    Private Sub TextBox10_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox10.TextChanged
        If ListView1.SelectedItems.Count = 1 Then
            Dim row As DataRowView = ListView1.SelectedItem
            row.Row("Breite") = TextBox10.Text
            SaveDataTable(ListView1.DataContext)
        End If
    End Sub

    ''' <summary>
    ''' Button hoch
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Button2_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles Button2.Click
        If ListView1.SelectedItems.Count = 1 Then
            Dim row As DataRowView = ListView1.SelectedItem
            Dim rowtemp As DataRow = tbl_rechnung.NewRow
            rowtemp.ItemArray = row.Row.ItemArray
            Dim pos As Integer = tbl_rechnung.Rows.IndexOf(row.Row)
            tbl_rechnung.Rows.Remove(row.Row)
            tbl_rechnung.Rows.InsertAt(rowtemp, pos - 1)
            ListView1.SelectedIndex = pos - 1
            SaveDataTable(ListView1.DataContext)
        End If
    End Sub

    ''' <summary>
    ''' Button Element runter
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Button3_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles Button3.Click
        Dim row As DataRowView = ListView1.SelectedItem
        Dim rowtemp As DataRow = tbl_rechnung.NewRow
        rowtemp.ItemArray = row.Row.ItemArray
        Dim pos As Integer = tbl_rechnung.Rows.IndexOf(row.Row)
        tbl_rechnung.Rows.Remove(row.Row)
        tbl_rechnung.Rows.InsertAt(rowtemp, pos + 1)
        ListView1.SelectedIndex = pos + 1
        SaveDataTable(ListView1.DataContext)
    End Sub

    Private Sub ComboBox2_SelectionChanged(sender As System.Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles ComboBox2.SelectionChanged
        If ComboBox2.SelectedIndex = 0 Then
            ListView1.DataContext = tbl_rechnung
        End If
        If ComboBox2.SelectedIndex = 1 Then
            ListView1.DataContext = tbl_lieferschein
        End If
        If ComboBox2.SelectedIndex = 2 Then
            ListView1.DataContext = tbl_angebot
        End If
        If ComboBox2.SelectedIndex = 3 Then
            ListView1.DataContext = tbl_gutschrift
        End If
    End Sub

    Private Sub TextBox8_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox8.TextChanged

    End Sub

    Private Sub TextBox7_GotFocus(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles TextBox7.GotFocus
        Dim img As New BitmapImage()
        img.BeginInit()
        img.UriSource = New Uri("pack://application:,,,/Standardlayout;component/Icon/pic1.png")
        img.EndInit()

        _parentform.Dispatcher.BeginInvoke(Sub()
                                               _parentform.LayoutImageControl.Stretch = Stretch.Uniform
                                               _parentform.LayoutImageControl.Source = img
                                           End Sub)
    End Sub

    Private Sub TextBox1_GotFocus(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles TextBox1.GotFocus
        Dim img As New BitmapImage()
        img.BeginInit()
        img.UriSource = New Uri("pack://application:,,,/Standardlayout;component/Icon/pic3.png")
        img.EndInit()

        _parentform.Dispatcher.BeginInvoke(Sub()
                                               _parentform.LayoutImageControl.Stretch = Stretch.Uniform
                                               _parentform.LayoutImageControl.Source = img
                                           End Sub)
    End Sub

    Private Sub TextBox3_GotFocus(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles TextBox3.GotFocus
        Dim img As New BitmapImage()
        img.BeginInit()
        img.UriSource = New Uri("pack://application:,,,/Standardlayout;component/Icon/pic2.png")
        img.EndInit()

        _parentform.Dispatcher.BeginInvoke(Sub()
                                               _parentform.LayoutImageControl.Stretch = Stretch.Uniform
                                               _parentform.LayoutImageControl.Source = img
                                           End Sub)
    End Sub

    Private Sub TextBox2_GotFocus(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles TextBox2.GotFocus
        Dim img As New BitmapImage()
        img.BeginInit()
        img.UriSource = New Uri("pack://application:,,,/Standardlayout;component/Icon/pic4.png")
        img.EndInit()

        _parentform.Dispatcher.BeginInvoke(Sub()
                                               _parentform.LayoutImageControl.Stretch = Stretch.Uniform
                                               _parentform.LayoutImageControl.Source = img
                                           End Sub)
    End Sub

    Private Sub TextBox4_GotFocus(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles TextBox4.GotFocus
        Dim img As New BitmapImage()
        img.BeginInit()
        img.UriSource = New Uri("pack://application:,,,/Standardlayout;component/Icon/pic7.png")
        img.EndInit()

        _parentform.Dispatcher.BeginInvoke(Sub()
                                               _parentform.LayoutImageControl.Stretch = Stretch.Uniform
                                               _parentform.LayoutImageControl.Source = img
                                           End Sub)
    End Sub

    Private Sub CheckBox1_GotFocus(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles CheckBox1.GotFocus
        Dim img As New BitmapImage()
        img.BeginInit()
        img.UriSource = New Uri("pack://application:,,,/Standardlayout;component/Icon/pic11.png")
        img.EndInit()

        _parentform.Dispatcher.BeginInvoke(Sub()
                                               _parentform.LayoutImageControl.Stretch = Stretch.Uniform
                                               _parentform.LayoutImageControl.Source = img
                                           End Sub)
    End Sub

    Private Sub TextBox5_GotFocus(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles TextBox5.GotFocus
        Dim img As New BitmapImage()
        img.BeginInit()
        img.UriSource = New Uri("pack://application:,,,/Standardlayout;component/Icon/pic7.png")
        img.EndInit()

        _parentform.Dispatcher.BeginInvoke(Sub()
                                               _parentform.LayoutImageControl.Stretch = Stretch.Uniform
                                               _parentform.LayoutImageControl.Source = img
                                           End Sub)
    End Sub


    Private Sub TextBox6_GotFocus(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles TextBox6.GotFocus
        Dim img As New BitmapImage()
        img.BeginInit()
        img.UriSource = New Uri("pack://application:,,,/Standardlayout;component/Icon/pic8.png")
        img.EndInit()

        _parentform.Dispatcher.BeginInvoke(Sub()
                                               _parentform.LayoutImageControl.Stretch = Stretch.Uniform
                                               _parentform.LayoutImageControl.Source = img
                                           End Sub)
    End Sub

    Private Sub TextBox9_GotFocus(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles TextBox9.GotFocus
        Dim img As New BitmapImage()
        img.BeginInit()
        img.UriSource = New Uri("pack://application:,,,/Standardlayout;component/Icon/pic10.png")
        img.EndInit()

        _parentform.Dispatcher.BeginInvoke(Sub()
                                               _parentform.LayoutImageControl.Stretch = Stretch.Uniform
                                               _parentform.LayoutImageControl.Source = img
                                           End Sub)
    End Sub

    Private Sub TextBox10_GotFocus(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles TextBox10.GotFocus
        Dim img As New BitmapImage()
        img.BeginInit()
        img.UriSource = New Uri("pack://application:,,,/Standardlayout;component/Icon/pic9.png")
        img.EndInit()

        _parentform.Dispatcher.BeginInvoke(Sub()
                                               _parentform.LayoutImageControl.Stretch = Stretch.Uniform
                                               _parentform.LayoutImageControl.Source = img
                                           End Sub)
    End Sub

    Private Function GetUIString(key As String) As String
        Try
            Return FindResource(key).ToString
        Catch ex As Exception
            Return key
        End Try
    End Function


    ''' <summary>
    ''' Seitenabstand nach oben Absender
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox11_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox11.TextChanged
        SaveSetting("Margin_Sender_Top", TextBox11.Text)
    End Sub

    ''' <summary>
    ''' Seitenabstand nach unten Absender
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox12_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox12.TextChanged
        SaveSetting("Margin_Sender_Bottom", TextBox12.Text)
    End Sub

    ''' <summary>
    ''' Seitenabstand nach oben Empfaenger
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox13_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox13.TextChanged
        SaveSetting("Margin_Receiver_Top", TextBox13.Text)
    End Sub

    ''' <summary>
    ''' Seitenabstand nach unten Empfaenger
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox14_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox14.TextChanged
        SaveSetting("Margin_Receiver_Bottom", TextBox14.Text)
    End Sub

    ''' <summary>
    ''' Seitenabstand nach oben Tabelle
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox15_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox15.TextChanged
        SaveSetting("Margin_Table_Top", TextBox15.Text)
    End Sub

    ''' <summary>
    ''' Seitenabstand nach unten Tabelle
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox16_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox16.TextChanged
        SaveSetting("Margin_Table_Bottom", TextBox16.Text)
    End Sub

    ''' <summary>
    ''' Datum linksbuendig
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RadioButton6_Checked(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles RadioButton6.Checked
        SaveSetting("Alignment_Date", "Left")
    End Sub

    ''' <summary>
    ''' Datum rechtsbuendig
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RadioButton8_Checked(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles RadioButton8.Checked
        SaveSetting("Alignment_Date", "Right")
    End Sub

    ''' <summary>
    ''' Seitenabstand nach oben Datum
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox18_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox18.TextChanged
        SaveSetting("Margin_Date_Top", TextBox18.Text)
    End Sub

    ''' <summary>
    ''' Seitenabstand nach unten Datum
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox19_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox19.TextChanged
        SaveSetting("Margin_Date_Bottom", TextBox19.Text)
    End Sub

    ''' <summary>
    ''' Seitenabstand Datum
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TextBox17_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox17.TextChanged
        SaveSetting("Margin_Date_Side", TextBox17.Text)
    End Sub

    Private Sub CheckBox4_Checked(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles CheckBox4.Checked
        SaveSetting("DeliveryAddress_On_Delivery", CheckBox4.IsChecked)
    End Sub

    Private Sub CheckBox4_Unhecked(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles CheckBox4.Unchecked
        SaveSetting("DeliveryAddress_On_Delivery", CheckBox4.IsChecked)
    End Sub

    Private Sub CheckBox7_Checked(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles CheckBox7.Checked
        SaveSetting("NoTaxes", CheckBox7.IsChecked)
    End Sub

    Private Sub CheckBox7_Unchecked(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles CheckBox7.Unchecked
        SaveSetting("NoTaxes", CheckBox7.IsChecked)
    End Sub

    Private Sub CheckBox5_Checked(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles CheckBox5.Checked
        SaveSetting("OrderGrossValues", CheckBox5.IsChecked)
    End Sub

    Private Sub CheckBox5_Unchecked(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles CheckBox5.Unchecked
        SaveSetting("OrderGrossValues", CheckBox5.IsChecked)
    End Sub

    Private Sub TextBox21_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox21.TextChanged
        SaveSetting("MarginLeftDocumentNumber", TextBox21.Text)
    End Sub

    Private Sub TextBox22_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox22.TextChanged
        SaveSetting("MarginTopDocumentNumber", TextBox22.Text)
    End Sub

    Private Sub TextBox23_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox23.TextChanged
        SaveSetting("MarginBotDocumentNumber", TextBox23.Text)
    End Sub

    Private Sub TextBox24_TextChanged(sender As System.Object, e As System.Windows.Controls.TextChangedEventArgs) Handles TextBox24.TextChanged
        SaveSetting("MarginSideTable", TextBox24.Text)
    End Sub

    ''' <summary>
    ''' Print username
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CheckBox8_Checked(sender As Object, e As RoutedEventArgs) Handles CheckBox8.Checked
        SaveSetting("ShowUserName", CheckBox8.IsChecked)
    End Sub

    ''' <summary>
    ''' Not Print username
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CheckBox8_Unchecked(sender As Object, e As RoutedEventArgs) Handles CheckBox8.Unchecked
        SaveSetting("ShowUserName", CheckBox8.IsChecked)
    End Sub

    ''' <summary>
    ''' Print userID
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CheckBox9_Checked(sender As Object, e As RoutedEventArgs) Handles CheckBox9.Checked
        SaveSetting("ShowUserID", CheckBox9.IsChecked)
    End Sub

    ''' <summary>
    ''' Not Print userID
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CheckBox9_Unchecked(sender As Object, e As RoutedEventArgs) Handles CheckBox9.Unchecked
        SaveSetting("ShowUserID", CheckBox9.IsChecked)
    End Sub

    Private Sub tb_fontSizeContent_LostFocus(sender As Object, e As RoutedEventArgs) Handles tb_fontSizeContent.LostFocus
        Try
            SaveSetting("FontSizeContent", CDbl(tb_fontSizeContent.Text))
        Catch ex As Exception
            MessageBox.Show("Tragen Sie eine Zahl ein")
        End Try
    End Sub

    Private Sub tb_fontSizeOrderID_LostFocus(sender As Object, e As RoutedEventArgs) Handles tb_fontSizeOrderID.LostFocus
        Try
            SaveSetting("FontSizeOrderID", CDbl(tb_fontSizeOrderID.Text))
        Catch ex As Exception
            MessageBox.Show("Tragen Sie eine Zahl ein")
        End Try
    End Sub

    Private Sub CheckBox6_Checked(sender As Object, e As RoutedEventArgs) Handles CheckBox6.Checked
        SaveSetting("InvoiceAddressOnlyOnFirstPage", CheckBox6.IsChecked)
    End Sub

    Private Sub CheckBox6_Unchecked(sender As Object, e As RoutedEventArgs) Handles CheckBox6.Unchecked
        SaveSetting("InvoiceAddressOnlyOnFirstPage", CheckBox6.IsChecked)
    End Sub

    Private Sub CheckBox10_Checked(sender As Object, e As RoutedEventArgs) Handles CheckBox10.Checked
        SaveSetting("ShowPageCount", CheckBox10.IsChecked)
    End Sub

    Private Sub CheckBox10_Unchecked(sender As Object, e As RoutedEventArgs) Handles CheckBox10.Unchecked
        SaveSetting("ShowPageCount", CheckBox10.IsChecked)
    End Sub

    Private Sub CB_ShowContactPerson_Checked(sender As Object, e As RoutedEventArgs) Handles CB_ShowContactPerson.Checked
        SaveSetting("ShowContactPerson", CB_ShowContactPerson.IsChecked)
    End Sub

    Private Sub CB_ShowContactPerson_Unchecked(sender As Object, e As RoutedEventArgs) Handles CB_ShowContactPerson.Unchecked
        SaveSetting("ShowContactPerson", CB_ShowContactPerson.IsChecked)
    End Sub

    Private Sub CheckBox11_Checked(sender As Object, e As RoutedEventArgs) Handles CheckBox11.Checked
        SaveSetting("AbroadInvoice", CheckBox11.IsChecked)
    End Sub

    Private Sub CheckBox11_Unchecked(sender As Object, e As RoutedEventArgs) Handles CheckBox11.Unchecked
        SaveSetting("AbroadInvoice", CheckBox11.IsChecked)
    End Sub
End Class
