Imports System

Public Class appsettings
    Private _configFileName As String 'local var to hold the config file name

    Public Function startuppath() As String
        Return System.AppDomain.CurrentDomain.BaseDirectory()
    End Function

    'initialize the apps config file, create it if it doesn't exist
    Private Sub InitializeConfigFile(ByVal path As String)
        Dim sb As New Text.StringBuilder

        sb.Append(path)

        _configFileName = sb.ToString 'completed config filename

        'if the file doesn't exist, create a blank xml
        If Not IO.File.Exists(_configFileName) Then
            Dim fn As New IO.StreamWriter(IO.File.Open(_configFileName, IO.FileMode.Create))
            fn.WriteLine("<?xml version=""1.0"" encoding=""utf-8""?>")
            fn.WriteLine("<LayoutConfiguration>")
            fn.WriteLine("  <Standardlayout>")
            fn.WriteLine("  </Standardlayout>")
            fn.WriteLine("</LayoutConfiguration>")
            fn.Close() 'all done
        End If
    End Sub

    'get an application setting by key value
    Public Function GetSetting(ByVal key As String, ByVal path As String) As String
        InitializeConfigFile(path)
        'xml dokument
        Dim xd As New Xml.XmlDocument

        'xml
        xd.Load(_configFileName)

        'query for a value
        Dim Node As Xml.XmlNode = xd.DocumentElement.SelectSingleNode( _
                                  "/LayoutConfiguration/Standardlayout/setting[@key=""" & key & """]")

        'return the value or nothing if it doesn't exist
        If Not Node Is Nothing Then
            Return Node.Attributes.GetNamedItem("value").Value
        Else
            Return Nothing
        End If
    End Function

    Public Sub save_xml_from_server(ByVal rpath As String, ByVal lpath As String)
        'InitializeConfigFile(rpath)
        Dim xd As New Xml.XmlDocument

        'xml
        Console.WriteLine(rpath)
        Console.WriteLine(lpath)
        xd.Load(rpath)

        Try
            IO.File.Delete(lpath)
        Catch ex As Exception

        End Try
        xd.Save(lpath)
    End Sub

    'get an application setting by key value
    Public Sub DeleteSetting(ByVal key As String, ByVal path As String)
        InitializeConfigFile(path)
        'xml dokument
        Dim xd As New Xml.XmlDocument

        'xml
        xd.Load(_configFileName)

        'query for a value
        Dim Node As Xml.XmlNode = xd.DocumentElement.SelectSingleNode( _
                                  "/LayoutConfiguration/Standardlayout/setting[@key=""" & key & """]")

        'return the value or nothing if it doesn't exist
        Try
            Node.RemoveAll()
        Catch ex As Exception

        End Try

        xd.Save(_configFileName)
    End Sub

    'Einstellung speichern
    Public Sub SaveSetting(ByVal key As String, ByVal value As String, ByVal path As String)
        InitializeConfigFile(path)
        'xml dokument
        Dim xd As New Xml.XmlDocument

        'xml
        Try
            xd.Load(_configFileName)
            'get the value
            Dim Node As Xml.XmlElement = CType(xd.DocumentElement.SelectSingleNode( _
                                               "/LayoutConfiguration/Standardlayout/setting[@key=""" & _
                                               key & """]"), Xml.XmlElement)
            If Not Node Is Nothing Then
                'key found, set the value
                Node.Attributes.GetNamedItem("value").Value = value
            Else
                'key not found, create it
                Node = xd.CreateElement("setting")
                Node.SetAttribute("key", key)
                Node.SetAttribute("value", value)

                'look for the appsettings node
                Dim Root As Xml.XmlNode = xd.DocumentElement.SelectSingleNode("/LayoutConfiguration/Standardlayout")

                'add the new child node (this key)
                If Not Root Is Nothing Then
                    Root.AppendChild(Node)
                Else
                    Try
                        'appsettings node didn't exist, add it before adding the new child
                        Root = xd.DocumentElement.SelectSingleNode("/LayoutConfiguration")
                        Root.AppendChild(xd.CreateElement("Standardlayout"))
                        Root = xd.DocumentElement.SelectSingleNode("/LayoutConfiguration/Standardlayout")
                        Root.AppendChild(Node)
                    Catch ex As Exception
                        'failed adding node, throw an error
                        Throw New Exception("Could not set value for Standardlayout", ex)
                    End Try
                End If
            End If

            'finally, save the new version of the config file
            Try
                xd.Save(_configFileName)
            Catch ex As Exception

            End Try
        Catch ex As Exception

        End Try

    End Sub
    Dim items As New ComboBox
    
End Class
